function initEvent(){
    if(typeof searchBtn != 'undefined' && searchBtn != null){
        searchBtn.addEventListener("tap", function () {
            prms = document.getElementById('searchTxt').value;
            loadSevice();
        });
    }

    mui("#categoryContent").on('tap', '.mui-control-item', function () {
        mui("#categoryContent .mui-control-item").each(function () {
            if (this.classList.contains("active")) {
                this.classList.remove("active");
            }
            if (!this.classList.contains("title")) {
                this.classList.add("title");
            }
        });
        this.classList.remove("title");
        this.classList.add("active");
        var categoryId = this.getAttribute("dataId");
        mui("#listdiv .detailCls").each(function () {
            if (!this.classList.contains("hidden")) {
                this.classList.add("hidden");
            }
        });
        document.getElementById("cardDetail_" + categoryId).classList.remove("hidden");
    });
    mui.back = function () {
        selfPage.close();
    };
    var localBtn = document.getElementById('localBtn');
    if(localBtn){
        localBtn.addEventListener('tap', function () {
            showShopSelector();
        });
    }
    window.addEventListener('setShop', function (e) {
        e = e.detail;
        var selectedShop = {
            soId:e.soId,
            soName:e.soName,
            fullName:e.fullName,
            siDownDatetime: e.siDownDatetime,
            siUpDatetime: e.siUpDatetime
        };
        shopid = e.soId;
        shopname = e.soName;
        setSelectedShop(selectedShop);
        showCurrentShop(selectedShop);
        loadSelShopService(selectedShop,function(){
            loadSevice();
        });

        plus.nativeUI.toast("已切换到门店：" + selectedShop.fullName);
    });
    mui("#listdiv").on('tap', '.change_shop_btn', function () {
        showShopSelector();
    });
    mui("#listdiv").on('tap', '.detail_link', function (){
        var me = this;
        var li = me.parentNode;
        var entityID = li.getAttribute('dataId');
        toServiceDetail(entityID);
    });

    mui("#listdiv").on('tap', '.downOrdeform', function () {
        getLoginState(function(ifLogin,data){
            if(!ifLogin){
                openLoginPageByUrl('login.html');
                return;
            }
            if(data.OK != 'OK'){
                openLoginPageByUrl('login.html');
                return;
            }
            var userInf = data.userInf || '';
            if(userInf == ''){
                openLoginPageByUrl('login.html');
                return;
            }
            placeAnOrder(this);
        });
    });
    // mui("#listdiv").on('tap', '.place_order_btn', function () {
    //     var servId = this.getAttribute("dataId");
    //     mui.openWindow({
    //         id: 'shopservice.html',
    //         url: 'shopservice.html',
    //         show: {
    //             aniShow: 'pop-in'
    //         },
    //         styles: {
    //             popGesture: 'hide'
    //         },
    //         waiting: {
    //             autoShow: true
    //         },
    //         extras: {
    //             servId: servId,
    //             lat: lat,
    //             longt: longt
    //         }
    //     });
    // });
}

function loadSevice() {
    if (!checknet()) {
        return;
    }
    var baseUtl=getServerUrlInf();
    var url="";
    var prams={
        page:'0',
        rows:'500'
    };
    url=baseUtl+'/accessFunNoLogin/excuteFun.do?funUrl=baseServiceInf/pageList.do&prms='+encodeURIComponent(JSON.stringify(prams))+'&temp='+new Date().getMilliseconds();
    getServerInfNoShowWaiting(url,{},function(data){
        if(data.OK=="OK"){
            var servArry=data.rows;
            servArry=JSON.parse(servArry);
            initServiceList(servArry);
        }else{
            plus.nativeUI.toast(data.message);
        }
    });
}
