//todo 用户登录失效之后，下单时提示“开单失败undefined”


function getPlaceOrderParams() {
    var servId = entityID;
    var dataSalePrice = entity.bsiSalePrice;
    var dataName = entity.fname;
    var selectedShop = getSelectedShop();
    return {
        servId: servId,
        soId: selectedShop.soId,
        soName: encodeURIComponent(selectedShop.soName),
        upTime: selectedShop.siUpDatetime,
        downTime: selectedShop.siDownDatetime,
        servsaleprice: dataSalePrice,
        servName: dataName,
        suId: '',
        vtype: 'servshop'
    };
}

function initEvent() {
    mui("#sliderSegmentedControl").on('tap', '.mui-control-item', function () {
        var me = this;
        var target = me.getAttribute('m_content');
        xmjs.style.display = 'none';
        syy.style.display = 'none';
        zysx.style.display = 'none';
        if (target == 'xmjs') {
            xmjs.style.display = 'block';
        } else if (target == 'syy') {
            syy.style.display = 'block';
        } else if (target == 'zysx') {
            zysx.style.display = 'block';
        }
    });

    //点击卡项，进入卡项下单页面
    mui("#syy").on('tap', '.buy_card_btn', function () {
        var me = this;
        var li = me.parentNode.parentNode.parentNode;
        getLoginState(function(ifLogin,data){
            if(!ifLogin){
                openLoginPageByUrl('login.html');
                return;
            }
            if(data.OK != 'OK'){
                openLoginPageByUrl('login.html');
                return;
            }
            var userInf = data.userInf || '';
            if(userInf == ''){
                openLoginPageByUrl('login.html');
                return;
            }
            placeACardOrder(li);
        });

    });

    document.getElementById('submitBtn').addEventListener('tap', function () {
        getLoginState(function(ifLogin,data){
            if(!ifLogin){
                openLoginPageByUrl('login.html');
                return;
            }
            if(data.OK != 'OK'){
                openLoginPageByUrl('login.html');
                return;
            }
            var userInf = data.userInf || '';
            if(userInf == ''){
                openLoginPageByUrl('login.html');
                return;
            }
            placeAnOrder();
        });
    });
}

function placeACardOrder(obj){
    //检查用户登录情况
    var curUser = app.getUserInf();
    if(curUser == null){
        openLoginPageByUrl('login.html');
        return;
    }


    var selectedShop = getSelectedShop();
    var shopid = selectedShop.soId;
    var shopname = selectedShop.soName;

    var arryList = [];
    var tempid = obj.getAttribute("dataId") || '';
    var datarow = {
        oiTemplateId: tempid,
        shopid: shopid,
        shopname: shopname,
        'oiSource':'0',
        'oiItemClass':'1',
        oiTemplateName: obj.getAttribute("dataName") || '',                 //名称
        oiSinglePrice: obj.getAttribute("dataPrice") || '',                 //单价
        oiUsableExtra: obj.getAttribute("dataDeductionFee") || '0',         //可使用红包
        oiNum: '1',         //购买数量
        oiUsableNum: obj.getAttribute("dataUsableNum") || '0',              //可用次数
        oiExtraMoney: obj.getAttribute("dataFreeFee") || '0',               //赠送红包
        oiIntegralPrice: obj.getAttribute("ctIntegralPrice") || '0',        //统一健康币价
        oiIntegral: obj.getAttribute("ctLargessIntegral") || '0'            //赠送健康币
    };
    
    arryList.push(JSON.stringify(datarow));

    mui.openWindow({
        id: 'pay.html',
        url: 'pay/pay.html',
        show: {
            aniShow: 'pop-in'
        },
        styles: {
            popGesture: 'hide'
        },
        waiting: {
            autoShow: true
        },
        extras: {
            itemArray: arryList,
            payClass: '1'
        }
    });


}

//读取服务对应的卡项信息
function loadServiceCard(serviceEntity) {
    //如果服务不能在手机端下单，则不显示卡项
    if (serviceEntity.bsiType == '1') {
        document.getElementById('cardSlider').style.display = 'none';
        return;
    }

    var selectedShop = getSelectedShop();
    var baseUtl = getServerUrlInf();
    var prams = {
        'cardTemplate.serviceId': entityID
        // 'usableServiceList.uslClass': '1'
        // 'orgId': selectedShop.soId
    };
    var url = baseUtl + '/accessFunNoLogin/excuteFun.do?funUrl=CardTemplate!findByServiceId.do';
    url += '&prms=' + encodeURIComponent(JSON.stringify(prams)) + '&temp=' + new Date().getMilliseconds();
    getServerInf(url, {}, function (data) {
        // if (data.OK != 'OK') {
        //     var msg = '发生错误！';
        //     if (data.message)
        //         msg += data.message;
        //     plus.nativeUI.toast(msg);
        //     return;
        // }
        var rows = data.rows;
        if (typeof rows == 'undefined') {
            var msg = '发生错误！';
            if (data.message)
                msg += data.message;
            plus.nativeUI.toast(msg);
            return;
        }
        if (typeof rows == 'string')
            rows = JSON.parse(rows);
        renderServiceCard(rows);
    });
}

/*
生成卡项的HTML，插入到 cardList
 */
function renderServiceCard(rows) {
	var cardList = document.getElementById('syyList');
    for (var i = 0; i < rows.length; i++) {
        var dataRow = rows[i];
        var freeFee = "0";
        var sumFreeFee = "0";
        if (dataRow.ctOne && dataRow.ctOne.length > 0) {
            freeFee = dataRow.ctOne;
            sumFreeFee = yunshuan(sumFreeFee, "+", freeFee);
        }
        if (dataRow.ctFive && dataRow.ctFive.length > 0) {
            freeFee = yunshuan(dataRow.ctFive, '*', "5");
            sumFreeFee = yunshuan(sumFreeFee, "+", freeFee);
        }
        if (dataRow.ctTen && dataRow.ctTen.length > 0) {
            freeFee = yunshuan(dataRow.ctTen, '*', "10");
            sumFreeFee = yunshuan(sumFreeFee, "+", freeFee);
        }
        if (dataRow.ctTwenty && dataRow.ctTwenty.length > 0) {
            freeFee = yunshuan(dataRow.ctTwenty, '*', "20");
            sumFreeFee = yunshuan(sumFreeFee, "+", freeFee);
        }
        if (dataRow.ctFifty && dataRow.ctFifty.length > 0) {
            freeFee = yunshuan(dataRow.ctFifty, '*', "50");
            sumFreeFee = yunshuan(sumFreeFee, "+", freeFee);
        }
        if (dataRow.ctHundred && dataRow.ctHundred.length > 0) {
            freeFee = yunshuan(dataRow.ctHundred, '*', "100");
            sumFreeFee = yunshuan(sumFreeFee, "+", freeFee);
        }
        var ctIntegralPrice = dataRow.ctIntegralPrice || 0;
        var ctLargessIntegral = dataRow.ctLargessIntegral || 0;
        var li = document.createElement("li");
        li.className = "mui-table-view-cell mui-media";
        li.style.paddingLeft = "5px";

        li.setAttribute('dataId',dataRow.ctId);
        li.setAttribute('dataName',dataRow.ctName);
        li.setAttribute('dataUsableNum',dataRow.ctUsableNum);
        li.setAttribute('dataFreeFee',sumFreeFee);
        li.setAttribute('dataPrice',dataRow.ctPrice);
        li.setAttribute('ctIntegralPrice',ctIntegralPrice);
        li.setAttribute('ctLargessIntegral',ctLargessIntegral);
        li.setAttribute('dataDeductionFee',dataRow.ctUsableExtra);
        var htmlTxt = [];
        if (dataRow.ctImgId && dataRow.ctImgId.length > 10) {
            var urlTxt = getFileServerUrlInf_sep() + "/fileserver/common/downloadfileServlet?fid=" + dataRow.ctImgId + "&isopen=0&filetype=4";
            htmlTxt.push('<img style="width:90px;height:90px;" class="mui-media-object mui-pull-left" src="images/translate.png" data-src="' + urlTxt + '" onload="load(this)"> ');
        } else {
            htmlTxt.push('<img style="width:90px;height:90px;" class="mui-media-object mui-pull-left" src="images/translate.png">');
        }
        htmlTxt.push('<div class="mui-media-body" >');
        htmlTxt.push('<div class="mui-row">');
        htmlTxt.push('<div class="mui-col-xs-8" style="min-height: 90px;height:100%;border-right:1px solid #EAEAEA;">');
        htmlTxt.push('<div style="font-size:14px;">' + dataRow.ctName + '</div>');
        htmlTxt.push('<p style="font-size:12px;">单张售价：￥<span style="color:red;">' + dataRow.ctPrice + '</span></p>');
        htmlTxt.push('<p>可用次数：<span style="color:red;">' + dataRow.ctUsableNum + '</span>次</p>');
        if (parseInt(sumFreeFee) > 0) {
            htmlTxt.push('<p style="font-size:12px;">赠送红包：￥<span style="color:red;">' + sumFreeFee + '</span></p>');
        }
        if (parseInt(ctLargessIntegral) > 0) {
            htmlTxt.push('<p style="font-size:12px;">赠送健康币：￥<span style="color:red;">' + ctLargessIntegral + '</span></p>');
        }
        if (parseInt(dataRow.ctUsableExtra) > 0) {
            htmlTxt.push('<p style="font-size:12px;">可用红包抵扣：￥' + dataRow.ctUsableExtra + '</span></p>');
        }
        htmlTxt.push('</div>');
        htmlTxt.push('<div class="mui-col-xs-4 buy_card_btn" style="min-height: 90px;height:100%;">');
        htmlTxt.push('<div style="padding:0.5rem;width:100%;text-align: center;position: absolute;top:40%;">点击购买</div>')
        htmlTxt.push('</div>');
        htmlTxt.push('</div>');
        if (dataRow.ctBriefIntroduction) {
            htmlTxt.push('<div style="color:#8f8f94;">&emsp;&emsp;' + dataRow.ctBriefIntroduction + '</span></div>');
        }
        li.innerHTML = htmlTxt.join('');
        cardList.appendChild(li);
    }


}

function placeAnOrder() {
    var dataprms = getPlaceOrderParams();
    mui.openWindow({
        id: 'serviceorderform.html',
        url: 'serviceorderform.html',
        show: {
            aniShow: 'pop-in'
        },
        styles: {
            popGesture: 'hide'
        },
        waiting: {
            autoShow: true
        },
        extras: dataprms
    });
}

function formatDate_f(time, fmt) {
    if (typeof time === 'undefined' || time == null || time === '')
        return "";
    if (typeof fmt === 'undefined' || fmt == null)
        fmt = "yyyy-MM-dd hh:mm:ss";
    var date = new Date(time);
    var o = {
        "M+": date.getMonth() + 1,                 //月份
        "d+": date.getDate(),                    //日 
        "h+": date.getHours(),                   //小时
        "m+": date.getMinutes(),                 //分
        "s+": date.getSeconds(),                 //秒
        "q+": Math.floor((date.getMonth() + 3) / 3), //季度
        "S": date.getMilliseconds()             //毫秒
    };
    if (/(y+)/.test(fmt))
        fmt = fmt.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt))
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length === 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
}

function loadData(id, onComplete) {
    var baseUtl = getServerUrlInf();
    var prams = {
        'id': id
    };
    var url = baseUtl + '/accessFunNoLogin/excuteFun.do?funUrl=baseServiceInf!findServiceInfById.do';
    url += '&prms=' + encodeURIComponent(JSON.stringify(prams)) + '&temp=' + new Date().getMilliseconds();
    getServerInf(url, {}, function (data) {

        var OK = data.OK;
        if (typeof OK == 'undefined' || OK != 'OK') {
            var msg = '发生错误！';
            if (data.message)
                msg += data.message;
            plus.nativeUI.toast(msg);
            return;
        }

        var baseServiceInf = data.baseServiceInf;
        if (typeof baseServiceInf == 'undefined') {
            plus.nativeUI.toast('发生错误2！');
            return;
        }
        if (typeof baseServiceInf == 'string')
            baseServiceInf = JSON.parse(baseServiceInf);
        entity = baseServiceInf;
        if (entity.bsiType != '1')
            document.getElementById('submitBtn').style.display = 'block';
        loadServiceCard(entity);
        renerInf(entity);
        var bsiImg = document.getElementById('bsiImg');
        var bsiImgId = entity.bsiImgId;
        if (typeof bsiImgId != 'undefined' && bsiImgId != 'undefined' && bsiImgId != '') {
            var fileServerURl = getFileServerUrlInf_sep() + "/fileserver/common/downloadfileServlet?";
            var imgUrlTxt = fileServerURl + 'fid=' + bsiImgId + '&isopen=0&filetype=4';
            bsiImg.setAttribute('data-src', imgUrlTxt);
            bsiImg.removeAttribute("data-loaded");
            load(bsiImg);
            // showPhoto(bsiImg);
        }

        // var imgs = contentDiv.getElementsByTagName('img');
        // for(var i=0;i<imgs.length;i++){
        // 	showPhoto(imgs[i]);
        // }
        // if(onComplete)
        //    onComplete(baseHealth);
        plus.nativeUI.closeWaiting();

    });
}

function renerInf(entity) {
    //{{entity.bsiAttention}}

    var bsiAttention = entity.bsiAttention;
    if (typeof bsiAttention == 'undefined')
        bsiAttention = '';
    // var fitIllnessData = entity.fitIllnessData;
    // if (typeof fitIllnessData == 'undefined')
    //     fitIllnessData = '';
    var bsiEffect = entity.bsiEffect;
    if (typeof bsiEffect == 'undefined')
        bsiEffect = '';

    document.getElementById('fnameShow').innerText = entity.fname;
    document.getElementById('bsiMinuteShow').innerText = entity.bsiMinute + '分钟';
    document.getElementById('bsiPostureShow').innerText = entity.bsiPostureTxt;
    // document.getElementById('syy').innerText = fitIllnessData;
    // '还没读出来，适用于机关工作、白领人士和上班一族由于压力大，缺乏锻炼或者经常熬夜所致的疲乏，眼干涩，皮肤松弛，腰酸背痛';
    document.getElementById('xmjs').innerHTML = bsiEffect;
    // document.getElementById('notFitIllnessDataShow').innerText = entity.notFitIllnessData;
    // document.getElementById('sywp_show').innerText = '用品，这个还没有';
    document.getElementById('zysx').innerText = bsiAttention;
    // document.getElementById('xdxz').innerText = '【这个还没有】下单须知';
    document.getElementById('bsiSalePriceShow').innerText = '￥' + entity.bsiSalePrice;
}


function showPhoto(img) {
    // var baseUtl = getFileServerUrlInf_sep();
    // var url = img.getAttribute('src');
    // url = baseUtl + url;
    // var deleteLink = document.createElement('a');
    // img.setAttribute("data-src",url);
    //移除此属性 否则不能下载图片
    img.removeAttribute("data-loaded");
    load(img);
}

