 /**
 * @description 通过ajax获取服务器信息
 * @param {Function} callback 参数为json格式
 */
function getServerInf(url,dataPrms,callback) {
	plus.nativeUI.showWaiting("数据加载中。。。");
	mui.ajax(url,{
		data:dataPrms,
		dataType:'json',//服务器返回json格式数据
		type:'post',//HTTP请求类型
		timeout:10000,//超时时间设置为10秒；
		success:function(data){				
			/*//验证session过期;如果session过期请重新登录
			if(data.OK && data.OK=="LOGIN"){
				 plus.nativeUI.toast('请重新登录！');					
				 mui.openWindow({
					id: getAppID(),
					show: {
						aniShow: 'pop-in'
					},
					waiting: {
						autoShow: true
					}
				});	
			}else{*/
				callback(data);				
			//}			
		},
		error:function(xhr,type,errorThrown){
			if(xhr.status==200){ 				
           		//plus.nativeUI.toast(xhr.responseText);
           		callback({'OK':'error',msg:xhr.responseText,message:xhr.responseText});	
            }else{
            	//plus.nativeUI.toast('亲，网络不给力，请再试试！');
            	callback({'OK':'error',msg:'亲，网络不给力，请再试试！',message:'亲，网络不给力，请再试试！'});	
            }
		},
		complete:function(xhr, ts){			
			plus.nativeUI.closeWaiting();				
		}
	});
}
function getServerInfNoShowWaiting(url,dataPrms,callback) {	
	mui.ajax(url,{
		data:dataPrms,
		dataType:'json',//服务器返回json格式数据
		type:'post',//HTTP请求类型
		timeout:10000,//超时时间设置为10秒；
		success:function(data){	
			//验证session过期;如果session过期请重新登录
			/*if(data.OK && data.OK=="LOGIN"){
				 plus.nativeUI.toast('请重新登录！');					
				 mui.openWindow({
					id: getAppID(),
					show: {
						aniShow: 'pop-in'
					},
					waiting: {
						autoShow: true
					}
				});	
			}else{*/
				callback(data);				
			/*}*/
		},
		error:function(xhr,type,errorThrown){
			if(xhr.status==200){ 				
           		//plus.nativeUI.toast(xhr.responseText);
           		callback({'OK':'error',msg:xhr.responseText,message:xhr.responseText});	
            }else{
            	//plus.nativeUI.toast('亲，网络不给力，请再试试！');
            	callback({'OK':'error',msg:'亲，网络不给力，请再试试！',message:'亲，网络不给力，请再试试！'});	
            }
		},
		complete:function(xhr, ts){	
		}
	});
}