/**
 * 支付js
 * todo 选择健康币抵扣，或项目卡抵扣之后，需要重新计算可用红包
 */

/*
初始化
1、读取 店铺相关的服务——卡项信息
2、读取会员信息，计算会员卡项、余额数据
3、读取订单信息，显示订单
 */
var allPayWays = [];
function init() {

    if(backFunc == 'add_order_close_page'){
        //关闭之前订单提交的页面
        mui.fire(plus.webview.getWebviewById(pwebViewID),backFunc);
    }
    getPayWays(function(){
        loadServiceCardRelation();
    });
}

function loadServiceCardRelation(){
    getAllServiceByOgnIdAndCard(function(){
        loadClientData(function(){
            if(orderID == ''){
                initWithData();
            }else{
                initWithOrderID();
            }
        });
    });
}

//=====
function initWithData(){
    var len = itemArray.length;
    var item_list = document.getElementById("item_list");
    var fragment = document.createDocumentFragment();
    var tmp = JSON.parse(itemArray[0]);
    shopid = tmp.shopid;
    shopname = tmp.shopname;
    document.getElementById('ognName').innerHTML = shopname;
    if (len <= 0)
        return;
    for (var i = 0; i < len; i++) {
        var dataRow = JSON.parse(itemArray[i]);
        var li = '';

        if (payClass == '0'){
            //服务
            renderService(dataRow,fragment,i);
        }else if(payClass == '1'){
            //项目卡
            renderProjectCard(dataRow,fragment,i);
        }else if(payClass == '2'){
            //充值卡
            renderStoredCard(dataRow,fragment,i);
        }else{
            plus.nativeUI.toast('参数有误，请退出重试！');
            return;
        }
        var p = dataRow.oiSinglePrice.trim();
        var n = dataRow.oiNum.trim();
        var saleprice = yunshuan(p, '*', n);
        saleSumPrince = yunshuan(saleprice, '+', saleSumPrince);
        saleRealPrice = saleSumPrince;
    }

    item_list.appendChild(fragment);

    document.getElementById("saleRealPriceShow").innerText = saleSumPrince;
    document.getElementById("realsumfee").innerText = '￥' + saleSumPrince;
    submitBtn.style.display = 'block';
    //手动初始化
    mui('.pointsSwitch').switch();
    mui('.cardsSwitch').switch();
    //健康币事件
    mui('.mui-table-view-cell').on('toggle', '.pointsSwitch', function () {
        var me = this;
        togglePointsSwitch(me);
    });
    //项目卡
    mui('.mui-table-view-cell').on('toggle', '.cardsSwitch', function () {
        var me = this;
        toggleCardsSwitch(me);
    });

}

function initWithOrderID(){
    getOrderByID(orderID,function (order,orderItem){
        orderItems = orderItem;
        var len = orderItems.length;
        var item_list = document.getElementById("item_list");
        var fragment = document.createDocumentFragment();
        var tmp = orderItems[0];

        shopid = order.ofOgnId;
        shopname = order.ofOgnName;
        document.getElementById('ognName').innerHTML = shopname;
        if (len <= 0)
            return;
        for (var i = 0; i < len; i++) {
            var dataRow = orderItems[i];
            // console.log(JSON.stringify(dataRow));
            var li = '';
            if (payClass == '0'){
                //服务
                renderService(dataRow,fragment,i);
            }else if(payClass == '1'){
                //项目卡
                renderProjectCard(dataRow,fragment,i);
            }else if(payClass == '2'){
                //充值卡
                renderStoredCard(dataRow,fragment,i);
            }else{
                plus.nativeUI.toast('参数有误，请退出重试！');
                return;
            }
            var p = dataRow.oiSinglePrice.trim();
            var n = dataRow.oiNum.trim();
            var saleprice = yunshuan(p, '*', n);
            saleSumPrince = yunshuan(saleprice, '+', saleSumPrince);
            saleRealPrice = saleSumPrince;
        }
        item_list.appendChild(fragment);
        showPayInfo(orderItems);
        document.getElementById("saleRealPriceShow").innerText = saleSumPrince;
        document.getElementById("realsumfee").innerText = '￥' + saleSumPrince;
        //手动初始化
        mui('.pointsSwitch').switch();
        mui('.cardsSwitch').switch();
        //健康币事件
        mui('.mui-table-view-cell').on('toggle', '.pointsSwitch', function () {
            var me = this;
            togglePointsSwitch(me);
        });
        //项目卡
        mui('.mui-table-view-cell').on('toggle', '.cardsSwitch', function () {
            var me = this;
            toggleCardsSwitch(me);
        });
        //项目卡单选框
        mui('.mui-table-view-cell').on('tap', '.card_radio', function () {
            var me = this;
            toggleCardsRadio(me);
        });
    });
}


//生成项目卡html
function renderProjectCard(dataRow,fragment,index){
    subItem.push({
        'oiItemClass': '1',
        'oiTemplateId': dataRow.oiTemplateId,
        'oiNum': dataRow.oiNum,
        'oiSource': '0',
        'oiSinglePrice': dataRow.oiSinglePrice
    });
    var deductionfee = dataRow.oiUsableExtra || 0;
    deductionfee = parseInt(deductionfee);

    useRedPacketsLimit += deductionfee;

    var li = document.createElement("li");
    li.className = "mui-table-view-cell";
    li.setAttribute("dataId", dataRow.oiTemplateId);
    li.setAttribute("dataName", dataRow.oiTemplateName);
    li.setAttribute("dataPrice", dataRow.oiSinglePrice);
    li.setAttribute("datanum", dataRow.oiNum);
    li.setAttribute('id', dataRow.oiTemplateId);
    li.setAttribute('ctIntegralPrice', dataRow.oiIntegralPrice);
    if (index > 0)
        li.setAttribute('style', 'border-top:#c8c7cc solid 1px;padding-top:1rem;');
    var htmlTxt = [];
    htmlTxt.push('卡项名称：'+dataRow.oiTemplateName);
    htmlTxt.push('<p>单张售价：￥<span class="redtext">' + dataRow.oiSinglePrice + '</span>');
    htmlTxt.push('<span class="mui-pull-right">购买数量：<span class="redtext">' + dataRow.oiNum + '</span>张</span>');
    htmlTxt.push('</p>');
    htmlTxt.push('<p>单张可用：<span class="redtext">' + dataRow.oiUsableNum + '</span>次');
    if (parseInt(dataRow.oiExtraMoney) > 0) {
        htmlTxt.push('<span class="mui-pull-right">单张赠送红包：￥<span class="redtext">' + dataRow.oiExtraMoney + '</span></span>');
    }
    htmlTxt.push('</p>');
    if (parseInt(deductionfee) > 0) {
        htmlTxt.push('<p>单张可用红包抵扣：￥<span class="redtext">' + deductionfee + '</span></p>');
    }
    li.innerHTML = htmlTxt.join('');
    fragment.appendChild(li);

    var li = renderPointsSwitch(dataRow);
    fragment.appendChild(li);
}
//生成服务html，服务html一定是通过订单id获取的
function renderService(dataRow,fragment,index){
    subItem.push({
        'oiItemClass': '0',
        'oiTemplateId': dataRow.oiTemplateId,
        'oiNum': dataRow.oiNum,
        'oiSource': '0',
        'oiSinglePrice': dataRow.oiSinglePrice
    });
    var deductionfee = dataRow.oiUsableExtra || 0;
    deductionfee = parseInt(deductionfee);

    useRedPacketsLimit += deductionfee;

    var li = document.createElement("li");
    li.className = "mui-table-view-cell";
    li.setAttribute("dataId", dataRow.oiTemplateId);
    li.setAttribute("dataName", dataRow.oiTemplateName);
    li.setAttribute("dataPrice", dataRow.oiSinglePrice);
    li.setAttribute("datanum", dataRow.oiNum);
    li.setAttribute('id', dataRow.oiTemplateId);
    li.setAttribute('ctIntegralPrice', dataRow.oiIntegralPrice);
    if (index > 0)
        li.setAttribute('style', 'border-top:#c8c7cc solid 1px;padding-top:1rem;');
    var htmlTxt = [];
    htmlTxt.push('服务名称：' + dataRow.oiTemplateName);
    htmlTxt.push('<p>单次价格：￥<span class="redtext">' + dataRow.oiSinglePrice + '</span>');
    htmlTxt.push('<span class="mui-pull-right">数量：<span class="redtext">' + dataRow.oiNum + '</span>次</span>');
    htmlTxt.push('</p>');

    htmlTxt.push('<p>房&emsp;&emsp;间：<span class="redtext">' + dataRow.oiRoomNumber + '</span>');
    htmlTxt.push('<span class="mui-pull-right">座位：<span class="redtext">' + dataRow.oiSeatNumber + '</span>次</span>');
    htmlTxt.push('</p>');

    htmlTxt.push('<p>安排上钟时间：'+dataRow.oiServiceBegintime.substring(0,16)+'</p>');
    htmlTxt.push('<p>预计下钟时间：'+dataRow.oiServiceEndtime.substring(0,16)+'</p>');
    htmlTxt.push('<p>安排技师：'+dataRow.oiArtificerName+'</p>');
    if(dataRow.oiWorkBegintime && dataRow.oiWorkBegintime.length>5){
        htmlTxt.push('<p>上钟时间：'+dataRow.oiWorkBegintime.substring(0,16)+'</p>');
        var upDownTxt="";
        if(dataRow.oiWorkEndtime && dataRow.oiWorkEndtime.length>5){
            htmlTxt.push('<p>下钟时间：'+dataRow.oiWorkEndtime.substring(0,16)+'</p>');
        }
    }
    var payState="未支付";
    var servState="待服务";
    if(dataRow.oiPayState=="1"){
        payState="已支付";
    }
    if(dataRow.oiServiceState=="1"){
        servState="服务中";
    }else if(dataRow.oiServiceState=="2"){
        servState="已服务";
    }
    htmlTxt.push('<p>支付状态：'+payState+'<span class="mui-pull-right">服务状态：'+servState+'</span></p>');
    li.innerHTML = htmlTxt.join('');
    fragment.appendChild(li);


    var li = renderPointsSwitch(dataRow);
    fragment.appendChild(li);

    //卡项抵扣，只有服务能用卡项抵扣
    renderPayWithCard(dataRow,fragment);

    //项目卡事件
    mui('.mui-table-view-cell').on('toggle', '.cardsSwitch', function () {
        var me = this;
        togglePointsSwitch(me);
    });
}

/*
显示卡项抵扣开关，与cardAndServiceRelationList对比
 */
function renderPayWithCard(dataRow,fragment){
    var li = document.createElement("li");
    li.className = "mui-table-view-cell cardsSwitchContainer";
    li.setAttribute('style', 'display:none;');
    var htmlTxt = [];
    var enableCard = getEnableCards(dataRow.oiTemplateId);

    htmlTxt.push('<span>项目卡抵扣</span>');
    htmlTxt.push('<span class="redtxt cardsShow" id="span_'+dataRow.oiTemplateId+'" style="margin-left:1rem;"></span>');
    htmlTxt.push('<div class="mui-switch mui-switch-mini cardsSwitch" dataId="' + dataRow.oiTemplateId + '">');
    htmlTxt.push('<div class="mui-switch-handle"></div>');
    htmlTxt.push('</div>');
    li.innerHTML = htmlTxt.join('');
    fragment.appendChild(li);

    var li = document.createElement("li");
    li.className = "mui-table-view-cell";
    li.setAttribute('style','display: none;');
    li.setAttribute('id','cardItem_'+dataRow.oiTemplateId);
    htmlTxt = [];
    htmlTxt.push('<div class="mui-input-group">');
    // console.log(JSON.stringify(enableCard));
    for(var j=0;j<enableCard.length;j++){
        var uslNum = enableCard[j].uslNum;
        var cardText = enableCard[j].ccCardName + '  剩余'+enableCard[j].ccNum + '次，　下卡次数：' + uslNum;
        var ccEndDate = enableCard[j].ccEndDate;
        if(typeof ccEndDate == 'undefined' ||ccEndDate == 'undefined')
            ccEndDate = '';
        cardText += '<br>有效期至：' + ccEndDate;
        htmlTxt.push('<div class="mui-input-row mui-radio">');
        htmlTxt.push('<label>'+cardText+'</label>');

        var h = '<input name="checkCard" class="card_radio" ';
        h += ' serviceID="'+dataRow.oiTemplateId+'" ccNum="'+enableCard[j].ccNum+'"';
        h += ' ccId="'+enableCard[j].ccId+'" uslNum="'+uslNum+'"';
        h += ' type="radio">';

        htmlTxt.push(h);
        htmlTxt.push('</div>');
    }

    htmlTxt.push('</div>');
    li.innerHTML = htmlTxt.join('');
    fragment.appendChild(li);
}

//获取服务可用的卡项
function getEnableCards(serviceID){
    var enableCardsAll = [];    //所有配置的可用此服务的卡项
    var enableCardsUser = [];   //顾客拥有的可用此服务的卡项
    //cardAndServiceRelationList
    //clientProjectCards
    for(var i=0;i<cardAndServiceRelationList.length;i++){
        if(cardAndServiceRelationList[i].uslServiceId == serviceID){
            enableCardsAll.push(cardAndServiceRelationList[i]);
        }
    }
    for(var i=0;i<clientProjectCards.length;i++){
        for(var j=0;j<enableCardsAll.length;j++){
            if(clientProjectCards[i].ccCardId == enableCardsAll[j].uslTemplateId){
                var card = clientProjectCards[i];
                card.uslNum = enableCardsAll[j].uslNum;
                enableCardsUser.push(card);
            }
        }
    }

    return enableCardsUser;
}

//项目卡开关
function toggleCardsSwitch(obj){
    var isActive = obj.classList.contains("mui-active");
    var dataId = obj.getAttribute('dataId');
    if (typeof dataId == 'undefined') {
        plus.nativeUI.toast('数据读取错误，不能使用项目卡抵扣！');
        return;
    }
    var cardEl = document.getElementById('cardItem_'+dataId);
    var tmpList = cardEl.getElementsByTagName('input');
    if(typeof cardEl=='undefined' || tmpList.length == 0){
        document.getElementById('span_'+dataId).innerHTML = '没有可用的卡项';
        removeClass(obj,'mui-active');
        obj.setAttribute('disabled',true);
        return;
    }
    if(isActive)
        cardEl.style.display = 'block';
    else{
        cardEl.style.display = 'none';
        //取消项目卡的使用
        resumeProjectCard(dataId);
        //去除此项目的所有radio选中状态
        var radios = cardEl.getElementsByTagName('input');
        for(var i=0;i<radios.length;i++){
            radios[i].checked = false;
        }

        //在项目里列表里取消项目卡支付的记录
        for (var i = 0; i < subItem.length; i++) {
            if (subItem[i].oiTemplateId == dataId) {
                subItem[i]['payWithCard'] = false;
                break;
            }
        }
        //重新计算金额
        calculateRealsumfee();
    }
}

/*
选择项目卡事件
同一服务，只能使用一个项目卡

1、记录为项目卡支付
2、减少项目卡次数
3、清空选中的红包
 */
function toggleCardsRadio(obj){
    var serviceID = obj.getAttribute('serviceID');

    //未选中的，恢复之前的数据
    resumeProjectCard(serviceID);

    //选中的，检查项目卡次数，记录使用项目卡
    var ccId = obj.getAttribute('ccId');
    var card = null;
    for(var i=0;i<clientProjectCards.length;i++){
        if(clientProjectCards[i].ccId == ccId){
            card = clientProjectCards[i];
            break;
        }
    }
    if(card!=null && (typeof card.uslNum != 'undefined') && card.uslNum != ''){
        //记录使用次数
        var uslNum = parseInt(card.uslNum);
        useProjectCard.push(card);
        var ccNum = parseInt(clientProjectCards[i].ccNum);
        if(ccNum<uslNum){
            //剩余次数不够
            document.getElementById('span_'+serviceID).innerHTML = '选中的卡项剩余次数不够';
            removeClass(obj,'mui-active');
            obj.setAttribute('disabled',true);
            calculateRealsumfee();
            return;
        }
        clientProjectCards[i].ccNum = ccNum - uslNum;
        //记录此项为卡项支付
        for (var i = 0; i < subItem.length; i++) {
            if (subItem[i].oiTemplateId == serviceID) {
                subItem[i]['payWithCard'] = true;
                subItem[i]['payWithCardID'] = card.ccId;
                subItem[i]['payWithCardNum'] = card.uslNum;
                break;
            }
        }
    }
    document.getElementById('span_'+serviceID).innerHTML = '';
    //重新计算金额
    calculateRealsumfee();
}

/*
恢复项目卡数据，用于取消项目卡时使用。
恢复项目卡次数、删除已选择的项目卡
clientProjectCards：用户所有项目卡
 */
function resumeProjectCard(serviceID){
    var card = null;
    for(var i=0;i<useProjectCard.length;i++){
        if(useProjectCard[i].ccId == serviceID){
            card = useProjectCard[i];
            //从使用的项目卡中移出对应项
            useProjectCard.splice(i,1);
            break;
        }
    }
    if(card == null)
        return;
    for(var i=0;i<clientProjectCards.length;i++){
        if(typeof card.uslNum == 'undefined' || card.uslNum == '')
            break;
        if(clientProjectCards[i].ccId == card.ccId){
            var uslNum = parseInt(card.uslNum);
            var ccNum = parseInt(clientProjectCards[i].ccNum);
            clientProjectCards[i].ccNum = ccNum + uslNum;
            break;
        }
    }
}

//显示健康币抵扣开关
function renderPointsSwitch(dataRow){
    var li = document.createElement("li");
    li.className = "mui-table-view-cell pointsSwitchContainer";
    li.setAttribute('style', 'display:none;');
    var ctIntegralPrice = dataRow.oiIntegralPrice || '0';
    var htmlTxt = [];
    if (ctIntegralPrice != '0') {
        htmlTxt.push('<span>健康币抵扣</span>');
        htmlTxt.push('<span class="redtxt pointsShow" style="margin-left:1rem;"></span>');
        htmlTxt.push('<div class="mui-switch mui-switch-mini pointsSwitch" dataId="' + dataRow.oiTemplateId + '">');
        htmlTxt.push('<div class="mui-switch-handle"></div>');
        htmlTxt.push('</div>');
    }
    li.innerHTML = htmlTxt.join('');
    return li;
}

//生成储值卡html
function renderStoredCard(dataRow,fragment,index){
    subItem.push({
        'oiItemClass': '2',
        'oiTemplateId': dataRow.oiTemplateId,
        'oiNum': dataRow.oiNum,
        'oiSource': '0',
        'oiSinglePrice': dataRow.oiSinglePrice
    });

    var li = document.createElement("li");
    li.className = "mui-table-view-cell";
    li.setAttribute("dataId", dataRow.oiTemplateId);
    li.setAttribute("dataName", dataRow.oiTemplateName);
    li.setAttribute("dataPrice", dataRow.oiSinglePrice);
    li.setAttribute("datanum", dataRow.oiNum);
    li.setAttribute('id', dataRow.oiTemplateId);
    li.setAttribute('ctIntegralPrice', dataRow.oiIntegralPrice);
    if (index > 0)
        li.setAttribute('style', 'border-top:#c8c7cc solid 1px;padding-top:1rem;')
    var htmlTxt = [];
    htmlTxt.push('卡项名称：' + dataRow.oiTemplateName);
    htmlTxt.push('<p>单张售价：￥<span class="redtext">' + dataRow.oiSinglePrice + '</span>');
    htmlTxt.push('<span class="mui-pull-right">购买数量：<span class="redtext">' + dataRow.oiNum + '</span>张</span>');
    htmlTxt.push('</p>');
    htmlTxt.push('<p>单张充值：<span class="redtext">' + dataRow.oiRealMonty + '</span>元');
    if (parseInt(dataRow.oiExtraMoney) > 0) {
        htmlTxt.push('<span class="mui-pull-right">单张赠送红包：￥<span class="redtext">' + dataRow.oiExtraMoney + '</span></span>');
    }
    htmlTxt.push('</p>');
    li.innerHTML = htmlTxt.join('');
    fragment.appendChild(li);
}

function initEvent() {
    // submitBtn.removeEventListener('tap',function(){
    //     submitOrder(this);
    // });
    submitBtn.addEventListener('tap', function () {
        submitOrder(this);
    });
    payBtn.addEventListener('tap', function (e) {
        payOrder(e);
    });

    mui.back = function () {
        selfPage.close();
    };
    mui('.mui-button-row').on('tap', '.mui-btn-danger', function() {
        document.getElementById("main").classList.add("hidden");
        document.getElementById("tbtpay").classList.add("hidden");
    });
    mui('.mui-button-row').on('tap', '.mui-btn-primary', function() {
        //获取支付参数
        var payParam = getPayParams();
        if(typeof payParam['makeCollections.phoneVerifyCode'] == 'undefined' || payParam['makeCollections.phoneVerifyCode'] == ''){
            mui.toast('请输入支付密码/验证码');
            return;
        }
        if(saleRealPrice >0){
            jumpToMoneyPayPage();
        }else
            postPayData(payParam);
    });

    //

    // window.addEventListener("init_Data", function () {
    //     loadClientData();
    // });
    //选择红包
    document.getElementById("payWithRedPockets").addEventListener('tap', function () {
        selectRedPackets();
    });

    //余额支付开关
    document.getElementById('storedCardSwitch').addEventListener('toggle', function () {
        toggleStoredCardSwitch(this);
    });
    //红包选择回调
    window.addEventListener('redPackets_selected', function (e) {
        e = e.detail;
        var redPockets = e.redPockets;
        redPackets_selected(redPockets);

    });
    //发送验证码
    checkNumBtn.addEventListener('tap', function(event) {
        var userinf = getUserInf();
        var phone = userinf.tel;
        if(typeof phone=='undefined' || phone.trim().length<11){
            plus.nativeUI.toast('未找到用户手机号，不能获取验证码!');
            return;
        }
        checkNumBtn.disabled = true;
        setInterval("cutDown(checkNumBtn)",1000);
        app.getCheckCode(phone,function(data){
            if(data.OK=="OK"){
                plus.nativeUI.toast('验证码已发送，请注意查收！');
            }else if(data.OK=="LOGIN"){
                openLoginPageByUrl("../login.html");
            }else{
                plus.nativeUI.toast(data.message);
            }
        });
    });
    
}

var cutDownSeconds = 60;
function cutDown(checkNumBtn){
    //mui-btn mui-btn-primary
    checkNumBtn.innerHTML = cutDownSeconds;
    if(cutDownSeconds<=0){
        checkNumBtn.innerHTML = '获取验证码';
        checkNumBtn.disabled = false;
        return;
    }
    cutDownSeconds--;
}

/*
健康币抵扣，单个项目设置
开启：总价-项目单价
关闭：总价+项目单价
点击后，需要重新选择使用的红包
 */
function togglePointsSwitch(obj) {
    var isActive = obj.classList.contains("mui-active");
    var dataId = obj.getAttribute('dataId');
    
    if (typeof dataId == 'undefined') {
        plus.nativeUI.toast('数据读取错误，不能使用健康币抵扣！');
        return;
    }
    var cardEl = document.getElementById(dataId);
    var ctIntegralPrice = cardEl.getAttribute('ctIntegralPrice') || '0';
    var datanum = cardEl.getAttribute('datanum') || '1';
    ctIntegralPrice = ctIntegralPrice.trim();
    datanum = datanum.trim();

    var itemTotalIntegral = yunshuan(ctIntegralPrice, '*', datanum);

    var showSpan = obj.parentElement.getElementsByClassName('pointsShow')[0];
    if (ctIntegralPrice == '0' || ctIntegralPrice == 0) {
        showSpan.innerHTML = '此商品不能使用健康币兑换';
        // obj.switch().toggle();
        removeClass(obj,'mui-active');
        obj.setAttribute('disabled',true);
        return;
    }
    
    if (isActive) {
        if (bcIntegral < itemTotalIntegral) {
            showSpan.innerHTML = '健康币不足';
            removeClass(obj,'mui-active');
            obj.setAttribute('disabled',true);
            return;
        }
        //记录对应项目为健康币抵扣
        for (var i = 0; i < subItem.length; i++) {
            if (subItem[i].oiTemplateId != dataId) {
                continue;
            }
            subItem[i]['payWithIntegral'] = true;
            subItem[i]['payIntegralCount'] = itemTotalIntegral;
            bcIntegral -= itemTotalIntegral;
        }
        //清空选中的红包
        useRedPackets = [];
        useRedPacketsFee = 0;
    } else {
        for (var i = 0; i < subItem.length; i++) {
            if (subItem[i].oiTemplateId != dataId) {
                continue;
            }
            subItem[i]['payWithIntegral'] = false;
            subItem[i]['payIntegralCount'] = 0;
            if (subItem[i]['payWithIntegral'])
                bcIntegral += itemTotalIntegral;
        }
        showSpan.innerHTM = '';
    }
    //
    //
    calculateRealsumfee();
}



//余额抵扣，可与红包公用
function toggleStoredCardSwitch(obj) {
    var isActive = obj.classList.contains("mui-active");
    //判断余额
    var clientStoreCardsTotal = clientStoreCards.total;
    if(typeof clientStoreCardsTotal=='undefined' ||clientStoreCardsTotal=='')
        clientStoreCardsTotal = 0;
    clientStoreCardsTotal = parseInt(clientStoreCardsTotal);

    if (clientStoreCardsTotal == 0) {
        document.getElementById("storedCardShow").innerText = '储值卡余额为0';
        removeClass(obj,'mui-active');
        obj.setAttribute('disabled',true);
        return;
    }

    if (isActive) {
        useStoredCard = true;
    } else {
        useStoredCard = false;
    }
    calculateRealsumfee();
}

//红包选择完毕事件
function redPackets_selected(redPockets) {

    var fragment = document.createDocumentFragment();
    var total = 0;
    for (var i = 0, len = redPockets.length; i < len; i++) {
        var type = redPockets[i].type;
        var num = redPockets[i].num;
        total += yunshuan(type, '*', num);
    }
    useRedPackets = redPockets;
    useRedPacketsFee = total;
    if (total > useRedPacketsLimit)
        useRedPacketsFee = useRedPacketsLimit;
    document.getElementById('redPocketsShow').innerHTML = '已抵扣 ' + useRedPacketsFee + '元';
    calculateRealsumfee();
}

/*
计算剩余支付的金额（修改红包、余额之后）
 */
function calculateRealsumfee() {
    saleRealPrice = 0;
    //计算总价（去除健康币抵扣、项目卡抵扣）
    for (var i = 0; i < subItem.length; i++) {
        if (subItem[i]['payWithIntegral'] == true || subItem[i]['payWithCard'] == true) {
            continue;
        }
        var oiSinglePrice = subItem[i].oiSinglePrice.trim();
        var num = subItem[i].oiNum.trim();
        var itemTotalPrice = yunshuan(oiSinglePrice, "*", num);
        saleRealPrice = yunshuan(saleRealPrice, "+", itemTotalPrice);
    }
    //计算总价（去除红包抵扣）
    saleRealPrice = yunshuan(saleRealPrice, "-", useRedPacketsFee);
    //计算总价（去除余额抵扣）
    if (useStoredCard) {
        useStoredCardFee = saleRealPrice;
        if (saleRealPrice > clientStoreCards.total)
            useStoredCardFee = clientStoreCards.total;
        document.getElementById("storedCardShow").innerText = '￥' + useStoredCardFee;
    } else {
        useStoredCardFee = 0;
        document.getElementById('storedCardShow').innerHTML = '';
    }
    saleRealPrice = yunshuan(saleRealPrice, "-", useStoredCardFee);
    document.getElementById("realsumfee").innerText = '￥' + saleRealPrice;
}

//支付订单 todo
function payOrder(e) {

    var param = getPayParams();
    console.log(JSON.stringify(param));

    if(checkUseSource()){
        //显示输入密码页面、遮罩
        document.getElementById("main").classList.remove("hidden");
        document.getElementById("tbtpay").classList.remove("hidden");
    }else
        jumpToMoneyPayPage();
}

function postPayData(payParam){
    var baseUtl=getServerUrlInf();
    
    var url=baseUtl+'/accessFunNoLogin/excuteFun.do?funUrl=makeCollections/';
    if(payClass == '0'){
    	url += 'addMakeCollections.do';
    }else if(payClass == '1'){
    	url += 'addCardMakeCollections.do';
    }
    
    url += '&prms='+encodeURIComponent(JSON.stringify(payParam))+'&temp='+new Date().getMilliseconds();
    getServerInf(url,{},function(data){
        if(data.OK=="OK"){
            // console.log('OK');
            mui.toast('支付成功');
            selfPage.close();
            mui.fire(plus.webview.getWebviewById(pwebViewID), backFunc, {});
        }else{
            plus.nativeUI.toast(data.message);
        }
    });
}

/*
获取支付参数
 */
function getPayParams(){
    var userinf = getUserInf();
    var payParam = {
        'makeCollections.mcSource': '0',
        'makeCollections.suId':'',
        'makeCollections.ognId': shopid,
        'makeCollections.bcPhone': userinf.tel,
        'makeCollections.phoneVerifyCode': '',  //支付密码
        'makeCollections.mcRealMoney': saleSumPrince,   //订单总金额
        'makeCollections.payTotalMoney': saleRealPrice,   //本次收款总金额
        'makeCollections.orderItemList':[],
        'makeCollections.integralList':[],
        'makeCollections.orderCardList': []
    };
    var password = document.getElementById('password').value;
    var checkCode = document.getElementById('checkCode').value;
    if(passwordType == 'password'){
        payParam['makeCollections.phoneVerifyCode'] = password;
    }else if(passwordType == 'checkCode'){
        payParam['makeCollections.phoneVerifyCode'] = checkCode;
    }
    var bcIntegralPay = 0;
    
    for(var i=0;i<orderItems.length;i++){
        //订单明细
        var orderItem = {
            oiId: orderItems[i].oiId,
            oiOfId: orderID
        };
        payParam['makeCollections.orderItemList'].push(orderItem);

        //健康币
        var payIntegralCount = subItem[i]['payIntegralCount'];
        if(typeof payIntegralCount == 'undefined')
            payIntegralCount = 0;
        payIntegralCount = parseInt(payIntegralCount);
        if(payIntegralCount > 0){
            var integralItem = {
                'integralItemId':orderItems[i].oiId,
                'integral' : payIntegralCount
            };
            bcIntegralPay += payIntegralCount;
            payParam['makeCollections.integralList'].push(integralItem);
        }

        //扣卡
        if(subItem[i].payWithCard){
            var ocddClientCardId = subItem[i].payWithCardID;
            var payWithCardNum = subItem[i].payWithCardNum;
            var projectCardItem = {
                ocddOrderId : orderID,
                ocddOrderDetailId: orderItems[i].oiId,
                ocddClientCardId: ocddClientCardId,
                ocddDeductNum: payWithCardNum
            };
            payParam['makeCollections.orderCardList'].push(projectCardItem);
        }
    }
    // payParam['makeCollections.orderCardList'] = JSON.stringify(payParam['makeCollections.orderCardList']);
    // payParam['makeCollections.integralList'] = JSON.stringify(payParam['makeCollections.integralList']);
    // payParam['makeCollections.orderItemList'] = JSON.stringify(payParam['makeCollections.orderItemList']);

    payParam['makeCollections.bcIntegral'] = bcIntegralPay;

    //储值卡
    payParam['makeCollections.storeCardMoney'] = useStoredCardFee + '';
    payParam['makeCollections.storeCardList'] = getStoreCardPayInfo();

    //红包：useRedPackets：使用红包  useRedPacketsFee：红包抵扣金额
    var redEnvelopeList = [];
    if(typeof useRedPackets!='undefined'){
        for(var i=0;i<useRedPackets.length;i++){
            if((typeof useRedPackets[i].type == 'undefined')||(typeof useRedPackets[i].num == 'undefined'))
                continue;
            redEnvelopeList.push({
                ccNum: useRedPackets[i].num + '',
                ccMoney: useRedPackets[i].type + ''
            })
        }
    }
    payParam['makeCollections.redEnvelopeList'] = redEnvelopeList;
    payParam['makeCollections.redEnvelope'] = useRedPacketsFee;
    // "redEnvelopeList":"[  //扣除的红包列表
    // {
    //     "ccNum":"3",		//扣除数量
    //     "ccMoney":"100" 	//面值
    // }
    // ]",
    // "redEnvelope":"230"，//红包实际扣除总额
    // todo 应收总金额

    var czkName = "储值卡";
    var czkId = "6c336ba616ef42f49b33e420724ba3f2";
    for(var i=0;i<allPayWays.length;i++){
        if(allPayWays[i].mcwPyHead == '1'){
            czkName = allPayWays[i].mcwName;
            czkId = allPayWays[i].mcwId;
            break;
        }
    }
    czkName = encodeURIComponent(czkName);

    if(useStoredCardFee > 0){
        payParam['makeCollections.payDetailList'] = [{
            "mcpdMcwId": czkId,//收款方式id
            "mcpdName": czkName,//收银名称
            "mcpdMoney": useStoredCardFee + '',//收款金额
            "amId":""//账户ID，账户管理表主键
        }];
        // payParam['makeCollections.payDetailList'] = JSON.stringify(payParam['makeCollections.payDetailList']);
    }

    // "payTotalMoney":"",//本次收款总金额												0
    // "payDetailList":"[  //支付明细列表
    // {
    //     "mcpdMcwId":"1b3c7f9db12c42838bc55e9415b8fc77",//收款方式id
    //     "mcpdName":"微信支付",//收银名称
    //     "mcpdMoney":"100",//收款金额
    //     "amId":"1b3c7f9db12c42838bc55e9415b8fc77"//账户ID，账户管理表主键
    // }
    // ]"
    payParam['makeCollections.payTotalMoney'] = useStoredCardFee;


    return payParam;
}

function getStoreCardPayInfo(){
    if(typeof useStoredCardFee == 'undefined' || useStoredCardFee <= 0)
        return [];
    //排序？
    var storeCardList = clientStoreCards.list;
    var hasCal = 0;                     //已计算金额
    var release = useStoredCardFee;     //未计算金额
    var info = [];
    for(var i=0;i<storeCardList.length;i++){
        var ccMoney = parseInt(storeCardList[i].ccMoney);
        if(ccMoney < release){
            hasCal = ccMoney;
            release -= ccMoney;
            info.push({
                ccCardId: storeCardList[i].ccId,
                ccMoney: ccMoney + ''
            });
            continue;
        }
        if(ccMoney >= release){
            info.push({
                ccCardId: storeCardList[i].ccId,
                ccMoney: release + ''
            });
            break;
        }
    }
    return info;
}

//检查用户是否使用了余额、健康币、红包、卡项
function checkUseSource(){
    //储值卡
    if(useStoredCard)
        return true;

    //红包
    if(useRedPacketsFee > 0)
        return true;


    //健康币、项目卡
    for (var i = 0; i < subItem.length; i++){
        if(subItem[i]['payWithIntegral'] == true || subItem[i]['payWithCard'] == true)
            return true;
    }
}

function jumpToMoneyPayPage(){
    mui.alert('您还需要支付'+saleRealPrice+'元，目前系统尚未开通支付功能，请到收银台支付！');
    mui.openWindow({
        id: 'payment.html',
        url: 'payment.html',
        show: {
            aniShow: 'pop-in'
        },
        styles: {
            popGesture: 'hide'
        },
        waiting: {
            autoShow: true
        },
        extras: {
            saleRealPrice: saleRealPrice,
            ofOrderNumber: ofOrderNumber
        }
    });
}

function calculateRedPackets(clientInfo) {
    var creOne = parseInt(clientInfo.creOne || 0);
    var creFive = parseInt(clientInfo.creOne || 0);
    var creTen = parseInt(clientInfo.creOne || 0);
    var creTwenty = parseInt(clientInfo.creOne || 0);
    var creFifty = parseInt(clientInfo.creOne || 0);
    var creHundred = parseInt(clientInfo.creOne || 0);
    var total = 0;
    total += creOne;
    total += creFive * 5;
    total += creTen * 10;
    total += creTwenty * 20;
    total += creFifty * 50;
    total += creHundred * 100;
    return total;
}

//clientProjectCards  clientStoreCards
function calculateCardList(clientInfo) {
    var list = clientInfo.clientCardsList;
    var storeCardList = [];
    var storeCardTotal = 0;
    if (typeof list == 'undefined' || list.length == 0)
        return 0;
    for (var i = 0; i < list.length; i++) {
        //储值卡
        if (list[i].ccCardType == '0'){
            var ccMoney = list[i].ccMoney || 0;
            ccMoney = parseFloat(ccMoney);
            storeCardTotal += ccMoney;
            storeCardList.push(list[i]);
        }

        //项目卡
        if (list[i].ccCardType == '1'){
            clientProjectCards.push(list[i]);
        }
    }

    clientStoreCards = {
        total: storeCardTotal,
        list: storeCardList
    };
}

function submitOrder(obj) {
    obj.setAttribute('disabled', true);
    var len = subItem.length;
    if (len == 0) {
        mui.toast("没有购买明细！");
        return;
    }
    var userinf = getUserInf();
    if (!checknet()) {
        return;
    }

    var prms = {
        'orderForm.ofClientId': userinf.userid_1,
        'orderForm.ofMembershipNum': userinf.number,
        'orderForm.ofPhone': userinf.tel,
        'orderForm.ofSource': '0',
        'orderForm.ofAmountMoney': saleSumPrince,
        'orderForm.ofPsnNum': '0',
        'orderForm.ofOrderState': '0',
        'orderForm.ofOrderType': payClass,
        'orderForm.ofServiceState': '0',
        'orderForm.ofPayState': '0',
        'orderForm.ofOgnId': shopid,
        'orderForm.ofOgnName': shopname,
        'orderForm.createUser': userinf.userid_1,
        'orderForm.ofReceivableMoney': saleSumPrince,
        'orderForm.ofPaidMoney': '0',
        'orderForm.orderItemsData': JSON.stringify(subItem)
    };
    var baseUtl = getServerUrlInf();
    var saveurl = baseUtl + '/accessFun/excuteFun.do?funUrl=orderForm/addOrder.do&prms=' + encodeURIComponent(JSON.stringify(prms)) + '&temp=' + new Date().getMilliseconds();
    getServerInf(saveurl, {
        'other_param': 'orderForm.ofRemarks',
        'orderForm.ofRemarks': '线上售卡'
    }, function (data) {
        if (data.OK == "OK") {
            var Orderlist = data.Orderlist;
            if (typeof Orderlist == 'undefined') {
                mui.toast('未取到订单信息');
                return;
            }
            if (typeof Orderlist == 'string')
                Orderlist = JSON.parse(Orderlist);

            //订单提交成功以后，显示支付相关的信息
            var order = Orderlist[0];

            //订单ID
            orderID = order.ofId;
            ofOrderNumber = order.ofOrderNumber;
            //订单项
            orderItems = order.subList;

            showPayInfo(orderItems);
            //获取订单新信息
            // mui.alert("订单保存成功！");
            // selfPage.opener().close();
            // selfPage.close();
        } else if (data.OK == "LOGIN") {
            openLoginPageByUrl("../login.html");
        } else {
            mui.toast(data.message);
        }
    });
}

function getOrderByID(orderId,onComplete){
    var param = {
        'id':orderId
    };
    var baseUtl = getServerUrlInf();
    var saveurl = baseUtl + '/accessFun/excuteFun.do?funUrl=orderForm/findById.do&prms=' + encodeURIComponent(JSON.stringify(param)) + '&temp=' + new Date().getMilliseconds();
    getServerInfNoShowWaiting(saveurl,{},function(data){
        var orderForm = data.orderForm;
        if(typeof orderForm=='undefined'){
            plus.nativeUI.toast('订单读取错误！');
            return;
        }
        if(typeof orderForm == 'string')
            orderForm = JSON.parse(orderForm);
        getOrderItemByOrderID(orderForm,onComplete);
    });
}

function getPayWays(onComplete){
    var param = {
        'makeCollectionsWay.mcwState': '1'
    };
    var baseUtl = getServerUrlInf();
    var url = baseUtl + '/accessFun/excuteFun.do?funUrl=makeCollectionsWay/list.do&prms=';
    url +=  encodeURIComponent(JSON.stringify(param)) + '&temp=' + new Date().getMilliseconds();
    getServerInfNoShowWaiting(url,{},function(data){
        if (data.OK == "LOGIN") {
            openLoginPageByUrl("../login.html");
            return;
        }
        if(data.OK != 'OK'){
            mui.toast('支付信息读取错误！');
            return;
        }
        allPayWays = data.rows;
        if(typeof allPayWays == 'undefined'){
            mui.toast('支付信息读取错误！');
            return;
        }
        if(typeof allPayWays == 'string')
            allPayWays = JSON.parse(allPayWays);
        if(allPayWays.length <= 0)
        {
            mui.toast('支付信息读取错误！');
            return;
        }
        if(onComplete)
            onComplete();
    });
}

function getOrderItemByOrderID(orderForm,onComplete){
    var orderId = orderForm.ofId;
    var param = {
        'orderItems.oiOfId':orderId
    };
    var baseUtl = getServerUrlInf();
    var saveurl = baseUtl + '/accessFun/excuteFun.do?funUrl=orderItems/list.do&prms=' + encodeURIComponent(JSON.stringify(param)) + '&temp=' + new Date().getMilliseconds();
    getServerInfNoShowWaiting(saveurl,{},function(data){
        var orderItemsList = data.orderItemsList;
        if(typeof orderItemsList=='undefined'){
            plus.nativeUI.toast('订单项读取错误！');
            return;
        }
        if(typeof orderItemsList == 'string')
            orderItemsList = JSON.parse(orderItemsList);
        if(onComplete)
            onComplete(orderForm,orderItemsList);
    });
}

/*订单提交成功以后，显示支付相关的信息
按支付类型，初始化配置项
0：服务  ，可用：健康币、余额、红包、卡项
1：项目卡，可用：健康币、余额、红包
2：储值卡，可用：无
 */
function showPayInfo(subList) {
    //oiIntegralPrice
    if (payClass == '0' || payClass == '1') {
        document.getElementById('payWithRedPockets').style.display = 'block';   //红包
        document.getElementById('payWithBalance').style.display = 'block';      //余额
        //健康币抵扣开关
        var pointsSwitchContainer = document.getElementsByClassName('pointsSwitchContainer');
        if (pointsSwitchContainer != null) {
            for (var i = 0; i < pointsSwitchContainer.length; i++) {
                pointsSwitchContainer[i].style.display = 'block';
            }
        }
        //卡项抵扣开关
        var cardsSwitchContainer = document.getElementsByClassName('cardsSwitchContainer');
        if (cardsSwitchContainer != null) {
            for (var i = 0; i < cardsSwitchContainer.length; i++) {
                cardsSwitchContainer[i].style.display = 'block';
            }
        }
    }
    // if (payClass == '0')
    //     document.getElementById('payWithCard').style.display = 'block';      //卡项
    document.getElementById('titleShow').innerText = '支付确认';
    document.getElementById('jine_content').innerText = '还需支付金额';
    payBtn.style.display = 'block';
    submitBtn.style.display = 'none';
}

//获取店铺可用的服务和卡项对应表
function getAllServiceByOgnIdAndCard(onComplete){
    var baseUtl = getServerUrlInf();
    var prms = {
        'baseClient.bcPhone': curUser.tel,
        'baseClient.bcOgnId': shopid,
        'baseClient.flag': '0'
    };
    var saveurl = baseUtl + '/accessFun/excuteFun.do?funUrl=usableServiceList/getAllServiceByOgnIdAndCard.do&prms=';
    saveurl += encodeURIComponent(JSON.stringify(prms)) + '&temp=' + new Date().getMilliseconds();
    getServerInfNoShowWaiting(saveurl, {}, function (data) {
        if (data.OK == "LOGIN") {
            openLoginPageByUrl("../login.html");
            return;
        }
        if (data.OK != 'OK') {
            plus.nativeUI.toast(data.message);
            return;
        }
        if (typeof data.rows == 'string')
            data.rows = JSON.parse(data.rows);
        cardAndServiceRelationList = data.rows;

        if(onComplete)
            onComplete();
    });
}



function loadClientData(onComplete) {
    if (!checknet()) {
        return;
    }
    var baseUtl = getServerUrlInf();
    var prms = {
        'baseClient.bcPhone': curUser.tel,
        'baseClient.bcOgnId': shopid
        // 'baseClient.flag': '0'
    };

    var saveurl = baseUtl + '/accessFun/excuteFun.do?funUrl=baseClient/clientinfo.do&prms=';
    saveurl += encodeURIComponent(JSON.stringify(prms)) + '&temp=' + new Date().getMilliseconds();
    getServerInfNoShowWaiting(saveurl, {}, function (data) {
        if (data.OK == "LOGIN") {
            openLoginPageByUrl("../login.html");
            return;
        }
        if (data.OK != 'OK'){
            plus.nativeUI.toast(data.message);
            return;
        }
        if (typeof data.clientInfo == 'string')
            data.clientInfo = JSON.parse(data.clientInfo);
        var rowData = data.clientInfo;
        document.getElementById("userName").innerText = rowData.bcName;
        document.getElementById("realsumfee").innerText = '￥' + saleSumPrince;
        //红包
        redPacketsTotal = calculateRedPackets(rowData);
        //卡项、余额
        calculateCardList(rowData);
        //健康币（积分）
        
        bcIntegral = rowData.bcIntegral || '0';
        bcIntegral = parseInt(bcIntegral);
        if(onComplete)
            onComplete();
    });
}

// function loadNetShopInf() {
//     if (!checknet()) {
//         return;
//     }
//     var baseUtl = getServerUrlInf();
//     var saveurl = baseUtl + '/accessFunNoLogin/excuteFun.do?funUrl=sysOrg/getNetShopInf.do&prms=&temp=' + new Date().getMilliseconds();
//     getServerInfNoShowWaiting(saveurl, {}, function (data) {
//         if (data.OK == "OK") {
//
//             if(typeof data.sysOrg == 'string')
//                 data.sysOrg = JSON.parse(data.sysOrg);
//             if (data.sysOrg) {
//                 soId = data.sysOrg.soId;
//                 soName = data.sysOrg.soName;
//             }
//         } else {
//             plus.nativeUI.toast(data.message);
//         }
//     });
// }

function selectRedPackets() {

    var a = {
        pwebViewID: selfPage.id,
        backFunc: 'redPackets_selected',
        maxDeduction: useRedPacketsLimit,     //最大可用红包金额
        selData: useRedPackets           //已选择的红包
    };
    if(useRedPacketsLimit == 0){
        plus.nativeUI.toast('此订单不支持使用红包！');
        return false;
    }

    mui.openWindow({
        id: 'searchdeduction.html',
        url: '../dialog/searchdeduction.html',
        show: {
            aniShow: 'pop-in'
        },
        styles: {
            popGesture: 'hide'
        },
        waiting: {
            autoShow: true
        },
        extras: {
            pwebViewID: selfPage.id,
            backFunc: 'redPackets_selected',
            maxDeduction: useRedPacketsLimit,     //最大可用红包金额
            selData: useRedPackets           //已选择的红包
        }
    });
}

function removeClass(elem, cls) {
    if (hasClass(elem, cls)) {
        var newClass = ' ' + elem.className.replace(/[\t\r\n]/g, '') + ' ';
        while (newClass.indexOf(' ' + cls + ' ') >= 0) {
            newClass = newClass.replace(' ' + cls + ' ', ' ');
        }
        elem.className = newClass.replace(/^\s+|\s+$/g, '');
    }
}
function hasClass(elem, cls) {
    cls = cls || '';
    if (cls.replace(/\s/g, '').length == 0) return false; //当cls没有参数时，返回false
    return new RegExp(' ' + cls + ' ').test(' ' + elem.className + ' ');
}

function openDetail(v, obj) {
    if(passwordType == v) {
        return;
    }
    passwordType = v;
    var checkboxArray = [].slice.call(document.querySelectorAll(".title"));
    checkboxArray.forEach(function(box) {
        box.classList.remove("titleactice");
    });
    obj.classList.add("titleactice");
    if(v == 'password') {
        messageobj.classList.add("hidden")
        passwordobj.classList.remove("hidden")
    } else if(v == 'checkCode') {
        messageobj.classList.remove("hidden")
        passwordobj.classList.add("hidden")
    }
}