

function initEvent(){
    
    
}

function formatDate_f(time, fmt) {
    if (typeof time === 'undefined' || time == null || time === '')
        return "";
    if (typeof fmt === 'undefined' || fmt == null)
        fmt = "yyyy-MM-dd hh:mm:ss";
    var date = new Date(time);
    var o = {
        "M+": date.getMonth() + 1,                 //月份
        "d+": date.getDate(),                    //日 
        "h+": date.getHours(),                   //小时
        "m+": date.getMinutes(),                 //分
        "s+": date.getSeconds(),                 //秒
        "q+": Math.floor((date.getMonth() + 3) / 3), //季度
        "S": date.getMilliseconds()             //毫秒
    };
    if (/(y+)/.test(fmt))
        fmt = fmt.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt))
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length === 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
}

function loadData(id,onComplete){
	var baseUtl = getServerUrlInf();
	var prams = {
        'id':id
    };
	var url = baseUtl+'/accessFunNoLogin/excuteFun.do?funUrl=baseHealth!findById.do';
    url += '&prms='+encodeURIComponent(JSON.stringify(prams))+'&temp='+new Date().getMilliseconds();
	getServerInf(url, {}, function (data) {
		var baseHealth = data.baseHealth;
		var html = '';
		if (typeof baseHealth === 'undefined') {
            plus.nativeUI.toast('发生错误！');
            return;
        }
		if(typeof baseHealth=='string')
			baseHealth = JSON.parse(baseHealth);
		html = baseHealth.bhDetail;
		var contentDiv = document.getElementById('contentDiv');
		contentDiv.innerHTML = html;
		var imgs = contentDiv.getElementsByTagName('img');
		for(var i=0;i<imgs.length;i++){
			showPhoto(imgs[i]);
		}
        if(onComplete)
            onComplete(baseHealth);
        plus.nativeUI.closeWaiting();
        
    });
}


function showPhoto(img){
//	var urlTxt=getFileServerUrlInf()+"fid="+id+"&isopen=0&filetype=4";
	var baseUtl = getFileServerUrlInf_sep();
//  var url = baseUtl + '/fileserver/common/downloadfileServlet?fid='+id+'&isopen=0&filetype=4';
	var url = img.getAttribute('src');
	url = baseUtl + url;
	var deleteLink = document.createElement('a');
	img.setAttribute("data-src",url);
    //移除此属性 否则不能下载图片
    img.removeAttribute("data-loaded");
    load(img);
}

