function loadData() {
    if (!checknet()) {
        return;
    }
    var baseUtl = getServerUrlInf();
    var saveurl = baseUtl + '/clientRedEnvelope/getDataByClient.do?temp=' + new Date().getMilliseconds();
    getServerInfNoShowWaiting(saveurl, {}, function (data) {
        if (data.OK == "OK") {
            if (data.clientRedEnvelope) {
                renderRedPockets(data);
            }
            if (table.innerHTML.trim().length == 0) {
                table.innerHTML = noDataShowTxt;
            }
        } else if (data.OK == "LOGIN") {
            openLoginPageByUrl("../login.html");
        } else {
            plus.nativeUI.toast(data.message);
        }
    });
}

function init(){
    //计算已使用的红包
    totalUsed = 0;
    for(var i=0;i<selData.length;i++){
        var type=selData[i].type;
        var num = parseInt(selData[i].num);
        totalUsed += yunshuan(type,'*',num);
        totalNum += num;
    }
    document.getElementById('useAll').innerHTML = totalUsed;

    mui.back = function () {
        selfPage.close();
    };

    window.addEventListener("init_Data", function () {
        loadData();
    });
    document.getElementById("saveBtn").addEventListener('tap', function () {
        doSubmit();
    });
    mui('#content').on('tap', '.selCheck', function() {
        var me = this;
        checkBoxChange(me);
    });
    mui("#content").on('change', '.mui-input-numbox', function () {
        var me = this;
        changeRedPocketsInput(me);
    });
    

}

function renderRedPockets(data){
    table.innerHTML = "";
    var fragment = document.createDocumentFragment();
    if (data.clientRedEnvelope.creOne && parseInt(data.clientRedEnvelope.creOne) > 0) {
        createRedItem('1',data.clientRedEnvelope.creOne,fragment);
    }
    if (data.clientRedEnvelope.creFive && parseInt(data.clientRedEnvelope.creFive) > 0) {
        createRedItem('5',data.clientRedEnvelope.creFive,fragment);
    }
    if (data.clientRedEnvelope.creTen && parseInt(data.clientRedEnvelope.creTen) > 0) {
        createRedItem('10',data.clientRedEnvelope.creTen,fragment);
    }
    if (data.clientRedEnvelope.creTwenty && parseInt(data.clientRedEnvelope.creTwenty) > 0) {
        createRedItem('20',data.clientRedEnvelope.creTwenty,fragment);
    }
    if (data.clientRedEnvelope.creFifty && parseInt(data.clientRedEnvelope.creFifty) > 0) {
        createRedItem('50',data.clientRedEnvelope.creFifty,fragment);
    }
    if (data.clientRedEnvelope.creHundred && parseInt(data.clientRedEnvelope.creHundred) > 0) {
        createRedItem('100',data.clientRedEnvelope.creHundred,fragment);
    }
    table.appendChild(fragment);
    
    mui(".mui-numbox").numbox();
}

//红包数量改变时，计算使用红包金额，并限制可使用的最大红包数
function changeRedPocketsInput(obj){
    changeRedPockets(obj);
}

function changeRedPocketsCountPlus(obj){
    changeRedPockets(obj);
}

function changeRedPocketsMinus(obj){
    changeRedPockets(obj);
}

function  checkBoxChange(obj) {
    var dateType = obj.getAttribute('dateType');
    var input = document.getElementById('type'+dateType + 'num');
    var num = input.value;
    setSelDataAndCalculateTotal(dateType,num,obj.checked);
}

function changeRedPockets(obj){
    var div = obj.parentNode;
    var dateType = div.getAttribute('dateType');
    var checkbox = document.getElementById('checkbox_'+dateType);
    var input = document.getElementById('type'+dateType + 'num');

    //点加号时，自动勾选checkbox
    if(obj.value > 0)
        checkbox.setAttribute('checked',true);
    if(!checkbox.checked)
        return;
    var num = input.value;
    //更新数据
	setSelDataAndCalculateTotal(dateType,num,false);

}

/*
设置对应金额红包数，
计算红包总额
当总额超过限额时，给出提示
 */
function setSelDataAndCalculateTotal(type,num,ifReduce){
    totalUsed = 0;
    //取消复选框
    if(ifReduce){
        for(var i=0;i<selData.length;i++){
            if(selData[i].type == type){
                selData[i].num = 0;
                continue;
            }
			totalUsed += yunshuan(selData[i].type,'*',selData[i].num);
        }
        showAndCheck();
        return;
    }

    var find = false;
    for(var i=0;i<selData.length;i++){
        if(selData[i].type == type){
        	selData[i].num = num;
            find = true;
        }
        totalUsed += yunshuan(selData[i].type,'*',selData[i].num);
    }
    if(find){
    	showAndCheck();
        return;
    }
    //如果没有保存过的金额，则新加
    selData.push({
        type: type,
        num: num
    });
    totalUsed += yunshuan(type,'*',num);
    showAndCheck();
}

function  showAndCheck() {
    document.getElementById('useAll').innerHTML = totalUsed;
    if(totalUsed > maxDeduction){
        plus.nativeUI.toast("红包超过限额，请检查！");
    }
}

//创建红包html
function createRedItem(denomination,count,fragment){
    var li = document.createElement("li");
    li.className = "mui-table-view-cell";
    var sel_Num = selNum(denomination);
    var checkedTxt = "";
    if (parseInt(sel_Num) > 0) {
        checkedTxt = "checked";
    } else {
        sel_Num = "1";
    }
    var htmlTxt = [];
    htmlTxt.push('<table style="width:100%;table-layout:fixed;" cellSpacing="0" cellPadding="0"><tr><td style="width:50%;">');
    htmlTxt.push('红包面额：￥<span style="color:red">'+denomination+'</span>');
    htmlTxt.push('</td>');
    htmlTxt.push('<td>');
    htmlTxt.push('总计<span style="color:red;">' + count + '</span>张');
    htmlTxt.push('</td></tr></table>');
    htmlTxt.push('<span class="mui-input-row mui-checkbox mui-pull-right" style="width:100%;">');
    htmlTxt.push('<label></label><input name="checkbox" ' + checkedTxt + ' class="selCheck" id="checkbox_'+denomination+'" dataId="type'+denomination+'" dateType="'+denomination+'" type="checkbox">');
    htmlTxt.push('</span>');
    htmlTxt.push('抵扣数量：<div class="mui-numbox" data-numbox-min="0" dateType="'+denomination+'" data-numbox-max="' + count + '">');
    htmlTxt.push('<button class="mui-btn mui-btn-numbox-minus"  type="button">-</button>');
    htmlTxt.push('<input id="type'+denomination+'num" class="mui-input-numbox" type="number" value="' + sel_Num + '" />');
    htmlTxt.push('<button class="mui-btn mui-btn-numbox-plus" type="button">+</button>');
    htmlTxt.push('</div>');
    li.innerHTML = htmlTxt.join('');
    fragment.appendChild(li);
}

function selNum(type) {
    if (!selData || selData.length == 0) {
        return '-1';
    }
    for (var i = 0, len = selData.length; i < len; i++) {
        if (selData[i].type == type) {
            return selData[i].num;
        }
    }
}

function doSubmit(){
    //检查选择的红包是否超额
//  if(totalUsed > maxDeduction){
//      mui.confirm('您选择了'+totalUsed+'元红包，但是只能抵扣'+maxDeduction+'元，是否继续？', '', ['是','否'], function (e) {
//          if (e.index == 0) {
//              mui.fire(selfPage.opener(), backFunc, {
//                  redPockets: selData
//              });
//              selfPage.close();
//          }
//      });
//      return;
//  }

    if (selData.length == 0) {
        selfPage.close();
        return;
    }
    if(!check())
        return false;
    mui.fire(selfPage.opener(), backFunc, {
        redPockets: selData
    });
    selfPage.close();
}

/*
检查选择的红包，如果去掉一个面额最小的，总金额任大于限额，则return false;
 */
function check(){
	if(maxDeduction == 0){
		plus.nativeUI.toast('支付订单不支持使用红包！');
		return false;
	}
	if(totalNum <= 0)
		return true;
	var smallest = getSmallest();
	if(totalUsed - smallest >= maxDeduction){
		plus.nativeUI.toast('您选择了过多的红包，请检查！');
		return false;
	}
    return true;
}

function getSmallest(){
	var smallest = 999;
	for(var i=0;i<selData.length;i++){
		if(parseInt(selData[i].type)<smallest)
			smallest = parseInt(selData[i].type);
	}
	return smallest;
}
