function init(){
    var len=cardArry.length;
    var fragment = document.createDocumentFragment();
    var tmp = JSON.parse(cardArry[0]);
    shopid = tmp.shopid;
    shopname  = tmp.shopname;
    document.getElementById('ognName').innerHTML = shopname;
    if(len<=0)
        return;
    for(var i=0;i<len;i++){
        var dataRow=JSON.parse(cardArry[i]);
        subItem.push({
            'oiItemClass':'1',
            'oiTemplateId':dataRow.cardId,
            'oiNum':dataRow.num,
            'oiSource':'0',
            'oiSinglePrice':dataRow.salePrice
        });
        var deductionfee = dataRow.deductionfee || 0;
        deductionfee = parseInt(deductionfee);

        useRedPacketsLimit += deductionfee;

        var li=document.createElement("li");
        li.className="mui-table-view-cell";
        li.setAttribute("dataId",dataRow.cardId);
        li.setAttribute("dataName",dataRow.cardName);
        li.setAttribute("dataPrice",dataRow.salePrice);
        li.setAttribute("datanum",dataRow.num);
        li.setAttribute('id',dataRow.cardId);
        li.setAttribute('ctIntegralPrice',dataRow.ctIntegralPrice);
        if(i>0)
        	li.setAttribute('style','border-top:#c8c7cc solid 1px;padding-top:1rem;')
        var htmlTxt=[];
        htmlTxt.push(dataRow.cardName);
        htmlTxt.push('<p>单张售价：￥<span class="redtext">'+dataRow.salePrice+'</span>');
        // htmlTxt.push('<p><span class="redtext">'+dataRow.num+'</span>张</p>');
        htmlTxt.push('<span class="mui-pull-right">购买数量：<span class="redtext">'+dataRow.num+'</span>张</span>');
        htmlTxt.push('</p>');
        htmlTxt.push('<p>单张可用：<span class="redtext">'+dataRow.usableNum+'</span>次');
        if(parseInt(dataRow.freefee)>0){
            htmlTxt.push('<span class="mui-pull-right">单张赠送红包：￥<span class="redtext">'+dataRow.freefee+'</span></span>');
        }
        htmlTxt.push('</p>');
        if(parseInt(deductionfee)>0){
            htmlTxt.push('<p>单张可用红包抵扣：￥<span class="redtext">'+deductionfee+'</span></p>');
        }
        li.innerHTML=htmlTxt.join('');
        fragment.appendChild(li);
        
        li=document.createElement("li");
        li.className="mui-table-view-cell pointsSwitchContainer";
        li.setAttribute('style','display:none;');
        var ctIntegralPrice = dataRow.ctIntegralPrice || '0';
        htmlTxt = [];
        if(ctIntegralPrice!='0'){
            htmlTxt.push('<span>健康币抵扣</span>');
            htmlTxt.push('<span class="redtxt pointsShow" style="margin-left:1rem;"></span>');
            htmlTxt.push('<div class="mui-switch mui-switch-mini pointsSwitch" dataId="'+dataRow.cardId+'">');
            htmlTxt.push('<div class="mui-switch-handle"></div>');
            htmlTxt.push('</div>');
        }
        li.innerHTML=htmlTxt.join('');
        fragment.appendChild(li);
        var p = dataRow.salePrice.trim();
        var n = dataRow.num.trim();
        var saleprice=yunshuan(p,'*',n);
        // var deduction=yunshuan(dataRow.deductionfee,'*',dataRow.num);
        saleSumPrince=yunshuan(saleprice,'+',saleSumPrince);
        saleRealPrice = saleSumPrince;
        // sumdeduction=yunshuan(sumdeduction,'+',deduction);
    }
    // console.log('sumdeduction='+sumdeduction);
    // if(parseFloat(sumdeduction)>0){
    //     document.getElementById("decuctionSpan").classList.remove("hidden");
    //     document.getElementById("decuctionTile").classList.remove("hidden");
    //     document.getElementById("realdecuctionSpan").classList.remove("hidden");
    // }
    card_list.appendChild(fragment);
    //手动初始化
    mui('.mui-switch')['switch']();
    document.getElementById("saleRealPriceShow").innerText = saleSumPrince;
    // document.getElementById("sumdeduction").innerText=sumdeduction;
    loadClientData();
    loadNetShopInf();
    submitBtn.style.display = 'block';
}

function initEvent(){
    submitBtn.addEventListener('tap',function(){
        submitOrder(this);
    });
    payBtn.addEventListener('tap',function(e){
        payOrder(e);
    });

    mui.back = function() {
        selfPage.close();
    };

    window.addEventListener("init_Data",function(){
        loadClientData();
    });

    document.getElementById("redbag").addEventListener('tap',function(){
        selectRedPackets();
    });

    //健康币支付开关，打开后，清空其他支付抵扣
    // document.getElementById('pointsSwitch').addEventListener('tap',function(){
    //     togglePointsSwitch(this);
    // });

    //余额支付开关，打开后，清空其他支付抵扣
    document.getElementById('storedCardSwitch').addEventListener('tap',function(){
        toggleStoredCardSwitch(this);
    });

    window.addEventListener('redPackets_selected',function(e){
        e=e.detail;
        var redPockets = e.redPockets;
        redPackets_selected(redPockets);

    });
     mui('.mui-table-view-cell').on('tap','.pointsSwitch',function(){
         var me = this;
         togglePointsSwitch(me);
     });
    
}

/*
健康币抵扣，单个项目设置
开启：总价-项目单价
关闭：总价+项目单价
点击后，需要重新选择使用的红包
 */
function togglePointsSwitch(obj){
    var isActive = obj.classList.contains("mui-active");
    var dataId = obj.getAttribute('dataId');
    
    if(typeof dataId == 'undefined'){
        plus.nativeUI.toast('数据读取错误，不能使用健康币抵扣！');
        return;
    }
    
    var cardEl = document.getElementById(dataId);
    var ctIntegralPrice = cardEl.getAttribute('ctIntegralPrice') || '0';
    var datanum = cardEl.getAttribute('datanum') || '1';
    ctIntegralPrice = ctIntegralPrice.trim();
    datanum = datanum.trim();
    var itemTotalIntegral = yunshuan(ctIntegralPrice,'*', datanum);

    var showSpan = obj.parentElement.getElementsByClassName('pointsShow')[0];
    if(ctIntegralPrice == 0){
        showSpan.innerHTML = '此商品不能使用健康币兑换';
        return;
    }

    if(isActive){
        if(bcIntegral < itemTotalIntegral){
            showSpan.innerHTML = '健康币不足';
            return;
        }
        //记录对应项目为健康币抵扣
        for(var i=0;i<subItem.length;i++){
            if(subItem[i].oiTemplateId != dataId){
                continue;
            }
            subItem[i]['payWithIntegral'] = true;
            subItem[i]['payIntegralCount'] = itemTotalIntegral;
            bcIntegral -= itemTotalIntegral;
        }
    }else{
        for(var i=0;i<subItem.length;i++){
            if(subItem[i].oiTemplateId != dataId){
                continue;
            }
            subItem[i]['payWithIntegral'] = false;
            subItem[i]['payIntegralCount'] = 0;
            if(subItem[i]['payWithIntegral'])
                bcIntegral += itemTotalIntegral;
        }
        showSpan.innerHTM = '';
    }
    // useRedPackets = [];
    // useRedPacketsFee = 0;
    calculateRealsumfee();
}

//余额抵扣，可与红包公用
function toggleStoredCardSwitch(obj){
    var isActive = obj.classList.contains("mui-active");
    if(isActive){
        useStoredCard = true;
        // document.getElementById('storedCardShow').innerHTML = '使用' + useStoredCardFee + '余额抵扣';
        // document.getElementById("realsumfee").innerText='￥0';
    }else{
        // useStoredCardFee = 0;
        // document.getElementById('storedCardShow').innerHTML = '';
        useStoredCard = false;
        // document.getElementById("realsumfee").innerText='￥' + saleSumPrince;
    }
    calculateRealsumfee();
}

//红包选择完毕事件
function redPackets_selected(redPockets){

    var fragment = document.createDocumentFragment();
    var total = 0;
    for(var i=0,len=redPockets.length;i<len;i++){
        var type=redPockets[i].type;
        var num =redPockets[i].num;
        total += yunshuan(type,'*',num);
    }
    useRedPackets = redPockets;
    useRedPacketsFee = total;
    if(total > useRedPacketsLimit)
        useRedPacketsFee = useRedPacketsLimit;
    document.getElementById('redPocketsShow').innerHTML = '已抵扣 ' + useRedPacketsFee + '元';
    calculateRealsumfee();
}

/*
计算剩余支付的金额（修改红包、余额之后）
 */
function calculateRealsumfee(){
    saleRealPrice = 0;
    //计算总价（去除健康币抵扣）
    for(var i=0;i<subItem.length;i++){
        if(subItem[i]['payWithIntegral'] == true){
            continue;
        }
        var oiSinglePrice = subItem[i].oiSinglePrice.trim();
        var num = subItem[i].oiNum.trim();
        var itemTotalPrice = yunshuan(oiSinglePrice , "*" , num);
        saleRealPrice = yunshuan(saleRealPrice , "+" , itemTotalPrice);
    }
    //计算总价（去除红包抵扣）
    saleRealPrice  = yunshuan(saleRealPrice , "-" , useRedPacketsFee);
    //计算总价（去除余额抵扣）
    if(useStoredCard){
        useStoredCardFee = saleRealPrice;
        if(saleRealPrice > storedCardTotal)
            useStoredCardFee = storedCardTotal;
        document.getElementById("storedCardShow").innerText='￥' + useStoredCardFee;
    }else{
        useStoredCardFee = 0;
        document.getElementById('storedCardShow').innerHTML = '';
    }
    saleRealPrice  = yunshuan(saleRealPrice , "-" , useStoredCardFee);
    document.getElementById("realsumfee").innerText='￥'+ saleRealPrice;
}



//支付订单
function payOrder(e){
    //红包

    //健康币

    //余额

    //提交支付
    var info = document.getElementById("info");
    e.detail.gesture.preventDefault(); //修复iOS 8.x平台存在的bug，使用plus.nativeUI.prompt会造成输入法闪一下又没了
    var btnArray = ['取消', '确定'];
    mui.prompt('请输入密码：', '请输入支付密码', '提交订单', btnArray, function(e) {
        if(e.index == 1) {
            info.innerText = '提交成功';
            mui.openWindow({
                id: 'payment.html',
                url: 'payment.html',
                show: {
                    aniShow: 'pop-in'
                },
                styles: {
                    popGesture: 'hide'
                },
                waiting: {
                    autoShow: true
                },
                extras: {
                    saleRealPrice: saleRealPrice,
                    ofOrderNumber: ofOrderNumber
                }
            });
        } else {
            info.innerText = '提交失败';
        }
    });
//  document.querySelector('.mui-popup-input input').type = 'password';
}

function calculateRedPackets(clientInfo){
    var creOne = parseInt(clientInfo.creOne || 0);
    var creFive = parseInt(clientInfo.creOne || 0);
    var creTen = parseInt(clientInfo.creOne || 0);
    var creTwenty = parseInt(clientInfo.creOne || 0);
    var creFifty = parseInt(clientInfo.creOne || 0);
    var creHundred = parseInt(clientInfo.creOne || 0);
    var total = 0;
    total += creOne;
    total += creFive * 5;
    total += creTen * 10;
    total += creTwenty * 20;
    total += creFifty * 50;
    total += creHundred * 100;
    return total;
}

function calculateStoredCard(clientInfo){
    var list = clientInfo.clientCardsList;
    if(typeof list=='undefined' || list.length == 0)
        return 0;
    var total = 0;
    for(var i=0;i<list.length;i++){
        if(list[i].ccCardType != '1')
            continue;
        var ccMoney = list[i].ccMoney || 0;
        ccMoney = parseFloat(ccMoney);
        total += ccMoney;
        clientStoreCardsList.push(list[i]);
    }
    return total;
}

function submitOrder(obj){
    obj.setAttribute('disabled',true);
    var len=cardArry.length;
    if(len==0){
        mui.toast("没有购买明细！");
        return;
    }
    var userinf=getUserInf();
    if(!checknet()){
        return;
    }
    var prms={
        'orderForm.ofClientId':userinf.userid_1,
        'orderForm.ofMembershipNum':userinf.number,
        'orderForm.ofPhone':userinf.tel,
        'orderForm.ofSource':'0',
        'orderForm.ofAmountMoney':saleSumPrince,
        'orderForm.ofPsnNum':'0',
        'orderForm.ofOrderState':'0',
        'orderForm.ofOrderType':'1',
        'orderForm.ofServiceState':'0',
        'orderForm.ofPayState':'0',
        'orderForm.ofOgnId':shopid,
        'orderForm.ofOgnName':shopname,
        'orderForm.createUser':userinf.userid_1,
        'orderForm.ofReceivableMoney':saleSumPrince,
        'orderForm.ofPaidMoney':'0',
        'orderForm.orderItemsData':JSON.stringify(subItem)
    };
    var baseUtl=getServerUrlInf();
    var saveurl=baseUtl+'/accessFun/excuteFun.do?funUrl=orderForm/addOrder.do&prms='+encodeURIComponent(JSON.stringify(prms))+'&temp='+new Date().getMilliseconds();
    getServerInf(saveurl,{
        'other_param':'orderForm.ofRemarks',
        'orderForm.ofRemarks':'线上售卡'
    },function(data){
        if(data.OK=="OK"){
            var Orderlist = data.Orderlist;
            if(typeof Orderlist=='undefined'){
                mui.toast('未取到订单信息');
                return;
            }
            if(typeof Orderlist=='string')
                Orderlist = JSON.parse(Orderlist);
            console.log(JSON.stringify(Orderlist));
            //订单提交成功以后，显示支付相关的信息
            var order = Orderlist[0];

            //订单ID
            orderID = order.ofId;
            ofOrderNumber = order.ofOrderNumber;
            //订单项
            orderItems = order.subList;

            showPayInfo(order);
            //获取订单新信息
            // mui.alert("订单保存成功！");
            // selfPage.opener().close();
            // selfPage.close();
        }else if(data.OK=="LOGIN"){
            openLoginPageByUrl("login.html");
        }else{
            mui.toast(data.message);
        }
    });
}

//订单提交成功以后，显示支付相关的信息
function showPayInfo(order){
    var subList = order.subList;
    //oiIntegralPrice
    document.getElementById('redbag').style.display = 'block';
    document.getElementById('jine_content').innerText = '还需支付金额';
    document.getElementById('jinfen_yue').style.display = 'block';
    payBtn.style.display = 'block';
    submitBtn.style.display = 'none';
    //显示健康币抵扣开关
    var pointsSwitchContainer = document.getElementsByClassName('pointsSwitchContainer');
    for(var i=0;i<pointsSwitchContainer.length;i++){
    	pointsSwitchContainer[i].style.display = 'block';
    }
}

function loadClientData(){
    if(!checknet()){
        return;
    }
    var baseUtl=getServerUrlInf();
    // var saveurl=baseUtl+'/sysUser/getClientInf.do?temp='+new Date().getMilliseconds();
    var prms = {
        'baseClient.bcPhone':curUser.tel,
        'baseClient.bcOgnId': shopid,
        'baseClient.flag': '0'
    };
    
    var saveurl=baseUtl+'/accessFun/excuteFun.do?funUrl=baseClient/clientinfo.do&prms='+encodeURIComponent(JSON.stringify(prms))+'&temp='+new Date().getMilliseconds();
    getServerInfNoShowWaiting(saveurl,{},function(data){
        if(data.OK == "LOGIN"){
            openLoginPageByUrl("login.html");
            return;
        }
        if(data.OK != 'OK'){
            plus.nativeUI.toast(data.message);
            return;
        }
        if(typeof data.clientInfo == 'string')
            data.clientInfo = JSON.parse(data.clientInfo);
        var rowData = data.clientInfo;
        document.getElementById("userName").innerText = rowData.bcName;
        document.getElementById("realsumfee").innerText='￥'+saleSumPrince;
        storedCardTotal = calculateStoredCard(rowData);
        redPacketsTotal = calculateRedPackets(rowData);
        // document.getElementById("realdecuction").innerText="0";
    });
}
function loadNetShopInf(){
    if(!checknet()){
        return;
    }
    var baseUtl=getServerUrlInf();
    var saveurl=baseUtl+'/accessFunNoLogin/excuteFun.do?funUrl=sysOrg/getNetShopInf.do&prms=&temp='+new Date().getMilliseconds();
    getServerInfNoShowWaiting(saveurl,{},function(data){
        if(data.OK=="OK"){
            if(data.sysOrg){
                data.sysOrg=JSON.parse(data.sysOrg);
                soId=data.sysOrg.soId;
                soName=data.sysOrg.soName;
            }
        }else{
            plus.nativeUI.toast(data.message);
        }
    });
}

function selectRedPackets(){
    var selData=[];
    // mui("#decuctionList li").each(function(){
    //     var liType=this.getAttribute("dateType");
    //     var linum=this.getAttribute("dataNum");
    //     selData.push({type:liType,num:linum});
    // });
    mui.openWindow({
        id:  'searchdeduction.html',
        url: 'dialog/searchdeduction.html',
        show: {
            aniShow: 'pop-in'
        },
        styles: {
            popGesture: 'hide'
        },
        waiting: {
            autoShow: true
        },
        extras:{
            pwebViewID:selfPage.id,
            backFunc:'redPackets_selected',
            maxDeduction: useRedPacketsLimit,     //最大可用红包金额
            selData:useRedPackets           //已选择的红包
        }
    });
}