

function loadCateGory(){

    if(!checknet()){
        return;
    }
    document.getElementById("listdiv").innerHTML="";
    var baseUtl=getServerUrlInf();
    var url=baseUtl+'/accessFunNoLogin/excuteFun.do?';
    url += 'funUrl=baseSerivceCategory/getAllDataByClient.do&prms=&temp='+new Date().getMilliseconds();
    getServerInfNoShowWaiting(url,{},function(data){
        if(data.OK!="OK"){
            plus.nativeUI.toast(data.message);
            return;
        }
        data.rows=JSON.parse(data.rows);
        var len=data.rows.length;
        if(len<=0){
            mui.toast("未找到卡项分类，请联系管理员！");
            selfPage.close();
        }
        var htmlTxt=[];
        var fragment = document.createDocumentFragment();
        var index=0;
        for(var i=0;i<len;i++){
            var dataRow=data.rows[i];
            var divCls="hidden";
            var tdCls="title";

            if(index==0){
                divCls="";
                tdCls="active";
            }
            htmlTxt.push('<td valign="middle" style="border:none;">');
            htmlTxt.push('<div class="'+tdCls+' mui-control-item " dataId="'+dataRow.bscId+'" dataName="'+dataRow.bscName+'">'+dataRow.bscName+'</div>');
            htmlTxt.push('</td>');

            var div=document.createElement("div");
            div.className="detailCls "+divCls;
            div.setAttribute("id","cardDetail_"+dataRow.bscId);
            div.innerHTML='<div class="servBz" style="background:#fff;">&emsp;&emsp;'+dataRow.bscBz+'</div><ul dataId="'+dataRow.bscId+'" class="mui-table-view servCls" style="margin-top:2px;"></ul>';
            fragment.appendChild(div);
            index++;
        }
        document.getElementById("listdiv").appendChild(fragment);
        document.getElementById("categoryContent").innerHTML=htmlTxt.join('');
        loadSevice();

    });
}

function initServiceList(data) {
    if(data.length<=0){
        return;
    }
    mui("#listdiv .servCls").each(function () {
        var categoryId = this.getAttribute("dataId");
        var fragment = document.createDocumentFragment();
        var len = data.length;
        for (var i = 0; i < len; i++) {
            var dataRow = data[i];
            if (dataRow.categoryPath.indexOf(categoryId) != 1) {
                continue;
            }
            if (dataRow.bsiServiceName.indexOf(prms) < 0) {
                continue;
            }
            var servId = dataRow.bsiId;
            var name = dataRow.bsiServiceName;
            if(name.length > 12){
                name = name.substring(0,12) + '...';
            }
            while(name.length < 12){
                name += '　';
            }
            var recommend = dataRow.bsiRecommend;
            if(typeof recommend == 'undefined' || recommend == null)
                recommend = '';
            var li = document.createElement("li");
            li.className = "mui-table-view-cell mui-media";
            li.setAttribute("dataId", servId);
            li.style.paddingLeft = "5px";
            var htmlTxt = [];
            if (dataRow.bsiImgId && dataRow.bsiImgId.length > 10) {
                var urlTxt=getFileServerUrlInf()+"fid="+dataRow.bsiImgId+"&isopen=0&filetype=4";
                htmlTxt.push('<img class="mui-media-object mui-pull-left detail_link" src="'+translateImgSrc+'" data-src="' + urlTxt + '" onload="load(this)"> ');
            } else {
                htmlTxt.push('<img class="mui-media-object mui-pull-left detail_link" src="'+defaultServiceImageSrc+'"> ');
            }
            htmlTxt.push('<div class="mui-media-body" dataId="'+servId+'">');
            htmlTxt.push('<span class="mui-pull-left detail_link">');
            var ifRecomm = '<span class="mui-badge mui-badge-warning" style="border:1px solid #00CC99;border-radius: 50px;color:#00CC99;background:#fff;margin-right:0.7rem;" >荐</span>';
            if (dataRow.bsiIfRecomm != '1')
                ifRecomm = '';
            htmlTxt.push('<div>' + name + '</div>');
            htmlTxt.push('<p>'+ifRecomm+'&nbsp;</p>');
            htmlTxt.push('<p style="margin-top:2px;"><span class="mui-icon iconfont icon-shijian" style="font-size:12px;"></span>&nbsp;' + dataRow.bsiMinute + '分钟（' + dataRow.bsiPostureTxt + '）</p>');
            htmlTxt.push('<p  style="color:#DD524D;font-weight:600;font-size:16px;">￥'+dataRow.bsiSalePrice+'</p>');
            htmlTxt.push('</span>');

            htmlTxt.push('<span class="mui-pull-right">');
            htmlTxt.push('<p>&nbsp;</p><p>&nbsp;</p>');
            htmlTxt.push('<p>'+dataRow.topCategoryName+'</p>');
            if(dataRow.bsiType != '1'){
            	var className = '';
            	var buttonText = '';
            	if(typeof curShopServArry == 'undefined'){
                    className = 'downOrdeform';
                    buttonText = '下单';
            	}else{
            		if(checkServiceEnable(dataRow,curShopServArry)){
                        className = 'downOrdeform';
                        buttonText = '下单';
                    }
            		else{
                        className = 'change_shop_btn';
                        buttonText = '切换门店';
                    }
            	}
            	var h = '<p><button class="mui-btn mui-btn-success ' + className + '"';
            	h += 'dataId="' + dataRow.bsiId + '" dataSalePrice="' + dataRow.bsiSalePrice + '" dataName="' + dataRow.bsiServiceName + '" ';
            	h += 'style="padding-top:2px;padding-bottom:0px;background:#00CC99;border-color:#00CC99;">' + buttonText;
            	h += '</button></p>';
            	htmlTxt.push(h);
            }
            htmlTxt.push('</span>');
            htmlTxt.push('</div>');
            if(recommend != '')
                htmlTxt.push('<div class="detail_link" style="margin-top:0.5rem;"><p>' + recommend + '</p></div>');
            li.innerHTML = htmlTxt.join('');
            fragment.appendChild(li);
        }
        this.innerHTML = "";
        this.appendChild(fragment);
        if (this.innerHTML.trim().length == 0) {
            this.innerHTML = noDataShowTxt;
        }
    });
}




function placeAnOrder(obj){
    var servId = obj.getAttribute("dataId");
    var dataSalePrice = obj.getAttribute('dataSalePrice');
    var dataName = obj.getAttribute('dataName');
    var selectedShop = getSelectedShop();
    mui.openWindow({
        id: 'serviceorderform.html',
        url: downOrderlUrl,
        show: {
            aniShow: 'pop-in'
        },
        styles: {
            popGesture: 'hide'
        },
        waiting: {
            autoShow: true
        },
        extras: {
            servId: servId,
            soId: selectedShop.soId,
            soName: encodeURIComponent(selectedShop.soName),
            upTime: selectedShop.siUpDatetime,
            downTime: selectedShop.siDownDatetime,
            servsaleprice: dataSalePrice,
            servName: dataName,
            suId: '',
            vtype: 'servshop'
        }
    });
}

function toServiceDetail(id){
    mui.openWindow({
        id: 'serviceDetail.html',
        url: detailUrl,
        show: {
            aniShow: 'pop-in'
        },
        styles: {
            popGesture: 'hide'
        },
        waiting: {
            autoShow: true
        },
        extras: {
            pwebViewID:selfPage.id,
            entityID: id
        }
    });
}

function setShop(){
    var selectedShop = getSelectedShop();
    if(selectedShop!=null){
        showCurrentShop(selectedShop);

        return;
    }
    //获取手机定位
    getPosition(setAddr);
}
function setAddr(flag, data) {
    if (flag) {
        // localObj.innerHTML = data.addr;
        lat = "" + data.lat;
        longt = "" + data.longt;
    } else {
        plus.nativeUI.toast("获取定位失败，请选择门店！");
        lat = '102.73';
        longt = '25.04';
    }
    selectShop(lat,longt);
}

function checkServiceEnable(service,curShopService){
    var id = service.bsiId;
    for(var i=0;i<curShopService.length;i++){
        if(curShopService[i].bsiId == id){
            return true;
        }
    }
    return false;
}

function showShopSelector() {
    mui.openWindow({
        url:'dialog/shopSelector.html',
        id:'shopSelector.html',
        show: {
            aniShow: 'pop-in'
        },
        styles: {
            popGesture: 'hide'
        },
        waiting: {
            autoShow: true
        },
        extras: {
            pwebViewID: selfPage.id,
            backFunc: 'setShop'
        }
    })
}
function showCurrentShop(currentShop){
    var fullName = currentShop.soName;
    var local = document.getElementById("local");
    if(typeof local != 'undefined' && local != null)
        local.innerHTML = fullName;
}

/*
读取选择的门店服务
 */
function loadSelShopService(selectedShop,onComplete) {
    if (!checknet()) {
        return;
    }
    plus.nativeUI.showWaiting("数据加载中。。。");
    var baseUtl = getServerUrlInf();
    var url = "";
    var prams = {
        'baseServiceInf.ognId': selectedShop.soId,
        page: '0',
        rows: '500'
    };
    url = baseUtl + '/accessFunNoLogin/excuteFun.do?funUrl=baseServiceInf/pageList.do&prms=' + encodeURIComponent(JSON.stringify(prams)) + '&temp=' + new Date().getMilliseconds();
    getServerInfNoShowWaiting(url, {}, function (data) {
        plus.nativeUI.closeWaiting();
        if (data.OK == "OK") {
            curShopServArry = data.rows;
            if(typeof curShopServArry == 'string')
                curShopServArry = JSON.parse(curShopServArry);
        } else {
            plus.nativeUI.toast(data.message);
        }
        if(onComplete)
            onComplete();
    });
}