var MAXLOGINNUM = 5;//最大登录次数
var curloginnum = 0;//当前登录累计次数
/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/
(function ($, owner) {
    /**
     * 用户登录
     **/
    owner.login = function (loginInfo, tomain) {
        loginInfo = loginInfo || {};
        loginInfo.account = loginInfo.account || '';
        loginInfo.password = loginInfo.password || '';
        var baseUtl = getServerUrlInf();
        if (baseUtl.length < 5) {
            return;
        }
        loginButton.setAttribute("disabled", "disabled");
        var loginUrl = baseUtl + '/sysLogin/login.do';
        getServerInf(loginUrl, {
            'sysUser.bcLoginName': loginInfo.account,
            'sysUser.bcLoginPwd': loginInfo.password
        }, function (data) {
            if (data.OK == "OK") {
                curloginnum = 0;
                //保存用户基本信息
                var user = {
                    account: loginInfo.account,
                    password: '',
                    issave: false
                }
                if (data.user) {
                    user.username = data.user.bcLoginName || '';
                    user.tel = data.user.bcPhone || '';
                    user.email = data.user.bcEmail || '';
                    user.userid = data.user.bcId || '';
                    user.idcard = data.user.bcCertificateNum || '';
                    user.certificate = data.user.certificate || '';
                    user.imgid = data.user.bcLoginImg || '';
                    user.realusername = data.user.bcName || '';
                    user.ognid = data.user.bcOgnId || '';
                    user.ognname = data.user.bcOgnName || '';
                    user.number = data.user.bcClientNumber || '';
                    if (data.user.bcBirthday && data.user.bcBirthday.length > 9) {
                        user.birthday = data.user.bcBirthday.substring(0, 10);
                    } else {
                        user.birthday = "";
                    }
                    user.sex = data.user.bcSex || '';
                    user.sexname = data.user.bcSexName || '';
                    user.nation = data.user.bcNation || '';
                    user.userid_1 = data.user.bcId || '';
                } else {
                    user.username = '';
                    user.tel = '';
                    user.email = '';
                    user.userid = '';
                    user.idcard = '';
                    user.certificate = '';
                    user.imgid = '';
                    user.realusername = '';
                    user.ognid = '';
                    user.ognname = '';
                    user.birthday = '';
                    user.sex = '';
                    user.nation = '';
                    user.userid_1 = '';
                    user.number = '';
                }
                user.issave = loginInfo.issave;
                if (user.issave) {
                    user.password = loginInfo.password;
                } else {
                    user.password = "";
                }
                saveuser(user);
                //如果店铺信息发生变化 需要重新加载功能信息
                var openViewObj = plus.webview.currentWebview();

                if (openViewObj) {
                    if (openViewObj.opener().id == "mymain.html" || openViewObj.opener().id == "index.html") {

                    } else {
                        $.fire(plus.webview.getWebviewById(openViewObj.opener().id), "init_Data");
                    }
                }
                $.fire(plus.webview.getWebviewById("index.html"), "refresh_AdInf");
                $.fire(plus.webview.getWebviewById("mymain.html"), "init_UserBaseInf");
                $.fire(plus.webview.getWebviewById("mymain.html"), "init_Data");


                plus.webview.currentWebview().close();
            } else {
                plus.nativeUI.toast(data.msg);
                loginButton.removeAttribute("disabled");
                curloginnum++;
            }
        });
    };
    /**
     *  修改安全信息
     **/
    owner.resetpsw = function (securityInfo) {
        securityInfo = securityInfo || {};
        securityInfo.npsw = securityInfo.npsw || '';
        securityInfo.psw = securityInfo.psw || '';
        var data = {
            'baseClient.bcLoginPwd': securityInfo.npsw,
            'baseClient.oldPassword': securityInfo.psw,
            'baseClient.bcId': securityInfo.uid
        };
        var baseUtl = getServerUrlInf();
        if (baseUtl.length < 5) {
            return;
        }
        var url = baseUtl + '/accessFunNoLogin/excuteFun.do?funUrl=baseClient/updatePassword.do';
        url += '&prms=' + encodeURIComponent(JSON.stringify(data)) + '&temp=' + new Date().getMilliseconds();
        getServerInf(url, {}, function (data) {
            if (data.OK == "OK") {
                plus.nativeUI.toast('密码保存成功！');
                plus.runtime.restart();
            } else if (data.OK == "LOGIN") {
                openLoginPageByUrl("login.html");
            } else {
                plus.nativeUI.toast(data.message);
            }
        });
    };

    /**
     *  重置密码（通过验证码修改密码）
     **/
    owner.setPswWithCode = function (securityInfo, onComplete) {
        securityInfo = securityInfo || {};
        var baseUtl = getServerUrlInf();
        if (baseUtl.length < 5) {
            return;
        }
        // var saveurl=baseUtl+'/SysUser/updatePasswordByPhone.do';
        var url = baseUtl + '/accessFunNoLogin/excuteFun.do?funUrl=baseClient/updatePasswordbyPhone.do';
        url += '&prms=' + encodeURIComponent(JSON.stringify(securityInfo)) + '&temp=' + new Date().getMilliseconds();
        getServerInf(url, {}, function (data) {
            if (onComplete)
                onComplete(data);
        });
    };

    /**
     *  绑定手机号
     **/
    owner.setPhone = function (securityInfo, onComplete) {
        securityInfo = securityInfo || {};
        var baseUtl = getServerUrlInf();
        if (baseUtl.length < 5) {
            return;
        }
        // var saveurl=baseUtl+'/SysUser/updatePhone.do';
        var url = baseUtl + '/accessFunNoLogin/excuteFun.do?funUrl=baseClient/updatePhone.do';
        url += '&prms=' + encodeURIComponent(JSON.stringify(securityInfo)) + '&temp=' + new Date().getMilliseconds();
        getServerInf(url, {}, function (data) {
            if (onComplete)
                onComplete(data);
        });
    };

    /**
     *  获取验证码
     **/
    owner.getCheckCode = function (phone, onComplete) {
        phone = phone || '';
        var baseUtl = getServerUrlInf();
        if (baseUtl.length < 5) {
            return;
        }
        if (phone == '') {
            return;
        }
        var param = {
            'sysVerifyCode.svcPhone': phone
        };
        // var url=baseUtl+'/sysVerifyCode!add.do';
        var url = baseUtl + '/accessFunNoLogin/excuteFun.do?funUrl=sysVerifyCode/add.do';
        url += '&prms=' + encodeURIComponent(JSON.stringify(param)) + '&temp=' + new Date().getMilliseconds();
        getServerInf(url, {}, function (data) {
            if (onComplete)
                onComplete(data);
        });
    };

    /**
     * 修改基本信息
     **/
    owner.saveuserbaseinf = function (saveinf) {
        saveinf = saveinf || {};
        var username = saveinf.username;
        var baseUtl = getServerUrlInf();
        if (baseUtl.length < 5) {
            return;
        }
        var data = {
            'sysUser.bcName': encodeURIComponent(saveinf.username),
            'sysUser.bcSex': saveinf.sextypeid,
            'sysUser.bcNation': encodeURIComponent(saveinf.nation),
            'sysUser.bcBirthday': saveinf.birthday,
            'sysUser.bcId': saveinf.userid,
            'sysUser.bcLoginImg': saveinf.imgid
        };
        var saveurl = baseUtl + '/SysUser/update.do';
        getServerInf(saveurl, data, function (data) {
            if (data.OK && data.OK == "OK") {
                var userinf = JSON.parse(localStorage.getItem('$user_client'));
                userinf.realusername = saveinf.username;
                userinf.birthday = saveinf.birthday;
                userinf.sex = saveinf.sextypeid;
                userinf.nation = saveinf.nation;
                userinf.imgid = saveinf.imgid;

                saveuser(userinf);
                plus.nativeUI.toast('保存成功！');
                $.fire(plus.webview.getWebviewById("mymain.html"), 'init_UserBaseInf');
                $.back();
            } else if (data.OK == "LOGIN") {
                openLoginPageByUrl("login.html");
            } else {
                plus.nativeUI.toast(data.message);
            }
        });

    };
    /**
     * 新用户注册
     **/
    owner.reg = function (regInfo, callback) {
        /*callback = callback || $.noop;
        regInfo = regInfo || {};
        regInfo.account = regInfo.account || '';
        regInfo.password = regInfo.password || '';
        if (regInfo.account.length < 5) {
            return callback('用户名最短需要 5 个字符');
        }
        if (regInfo.password.length < 6) {
            return callback('密码最短需要 6 个字符');
        }
        if (!checkEmail(regInfo.email)) {
            return callback('邮箱地址不合法');
        }
        var users = JSON.parse(localStorage.getItem('$user_client') || '[]');
        users.push(regInfo);
        localStorage.setItem('$user_client', JSON.stringify(users));*/
        return callback();
    };

    var checkEmail = function (email) {
        email = email || '';
        return (email.length > 3 && email.indexOf('@') > -1);
    };

    /**
     * 找回密码
     **/
    owner.forgetPassword = function (email, callback) {
        /*callback = callback || $.noop;
        if (!checkEmail(email)) {
            return callback('邮箱地址不合法');
        }*/
        return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
    };

    /**
     * 设置是否保存用户信息
     **/
    var saveuser = function (user) {
        localStorage.setItem('$user_client', JSON.stringify(user));
    };

    /**
     * 获取用户信息
     **/
    owner.getUserInf = function () {
        var user = localStorage.getItem('$user_client');
        if (user) {
            return JSON.parse(localStorage.getItem('$user_client'));
        } else {
            return null;
        }
    };

}(mui, window.app = {}));